/* GEM Resource C Source */

#include <portab.h>
#include <aes.h>
#include "EG_RSC.H"

#if !defined(WHITEBAK)
#define WHITEBAK    0x0040
#endif
#if !defined(DRAW3D)
#define DRAW3D      0x0080
#endif

#define FLAGS9  0x0200
#define FLAGS10 0x0400
#define FLAGS11 0x0800
#define FLAGS12 0x1000
#define FLAGS13 0x2000
#define FLAGS14 0x4000
#define FLAGS15 0x8000
#define STATE8  0x0100
#define STATE9  0x0200
#define STATE10 0x0400
#define STATE11 0x0800
#define STATE12 0x1000
#define STATE13 0x2000
#define STATE14 0x4000
#define STATE15 0x8000

static  TEDINFO rs_tedinfo[] =
{ "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 61, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x11C8, 0, 0, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, 1, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x11C8, 0, 0, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, 1, 1, 1,
  "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 61, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x11C8, 0, 0, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, 1, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x11C8, 0, 0, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, 1, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x11C8, 0, 0, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, 1, 1, 1,
  "EGlib",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 6, 1,
  "----------Release  Date--------",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 32, 1,
  "Christophe Boyanique",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 21, 1,
  "29 Rue Republique",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 18, 1,
  "37230 FONDETTES",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 16, 1,
  "FRANCE",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 7, 1,
  "small mail: cb@spia.freenix.fr",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 31, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 1, 1,
  "GNU GENERAL PUBLIC LICENSE",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 27, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 1, 1,
  "patched by:",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 12, 1,
  "---------Info Patch 1---------",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 31, 1,
  "---------Info Patch 2---------",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1100, 0, -1, 31, 1,
  "MEMLEN",
  "Total:    ______ K",
  "999999",
  IBM  , 0, TE_LEFT , 0x1180, 0, -1, 7, 19,
  "FMEMFRE--------- K",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x1180, 0, -1, 19, 1,
  "FMEMSYS--------- K",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x1180, 0, -1, 19, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, -1, 1, 1,
  "VECT. FONT",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "The quick brown fox jumps over the lazy dog",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x11F0, 0, -1, 44, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, -1, 1, 1,
  "VECT. FONT",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "The quick brown fox jumps over the lazy dog",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x11F0, 0, -1, 44, 1,
  "\0",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 1, 1,
  "\0",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_LEFT , 0x1180, 0, -1, 1, 1,
  "12",
  "__",
  "99",
  IBM  , 0, TE_LEFT , 0x1180, 0, -1, 3, 3,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, -1, 1, 1,
  "\0",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, -1, 1, 1,
  "FOPTPHLP--------------------------",
  "\0",
  "\0",
  IBM  , 0, TE_CNTR , 0x1180, 0, -1, 35, 1,
  "ICONE-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "ICINF-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "ICMEM-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "ICFNT-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "ICOPT-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "ICSYS-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1,
  "ICHLP-----",
  "\0",
  "\0",
  SMALL, 0, TE_CNTR , 0x1100, 0, -1, 11, 1
};

static  WORD RSIB0MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB0DATA[] =
{ 0x0000, 0x07E0, 0x18F8, 0x20FC, 
  0x20FC, 0x40FE, 0x40FE, 0x40FE, 
  0x7F02, 0x7F02, 0x7F06, 0x3F04, 
  0x3F0C, 0x1F18, 0x07E0, 0x0000
};

static  WORD RSIB1MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB1DATA[] =
{ 0x0000, 0x07E0, 0x1818, 0x201C, 
  0x203C, 0x703E, 0x7C7E, 0x7FFE, 
  0x7FFE, 0x7E3E, 0x7C0E, 0x3C04, 
  0x3804, 0x1818, 0x07E0, 0x0000
};

static  WORD RSIB2MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB2DATA[] =
{ 0x0000, 0x07E0, 0x1818, 0x300C, 
  0x381C, 0x7C3E, 0x7E7E, 0x7FFE, 
  0x7FFE, 0x7E7E, 0x7C3E, 0x381C, 
  0x300C, 0x1818, 0x07E0, 0x0000
};

static  WORD RSIB3MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB3DATA[] =
{ 0x0000, 0x07E0, 0x1818, 0x3804, 
  0x3C04, 0x7C0E, 0x7E3E, 0x7FFE, 
  0x7FFE, 0x7C7E, 0x703E, 0x203C, 
  0x201C, 0x1818, 0x07E0, 0x0000
};

static  WORD RSIB4MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB4DATA[] =
{ 0x0000, 0x07E0, 0x1F18, 0x3F0C, 
  0x3F04, 0x7F06, 0x7F02, 0x7F02, 
  0x40FE, 0x40FE, 0x40FE, 0x20FC, 
  0x20FC, 0x18F8, 0x07E0, 0x0000
};

static  WORD RSIB5MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB5DATA[] =
{ 0x0000, 0x07E0, 0x1FF8, 0x3FE4, 
  0x3FC4, 0x5FC2, 0x4782, 0x4182, 
  0x4182, 0x41E2, 0x43FA, 0x23FC, 
  0x27FC, 0x1FF8, 0x07E0, 0x0000
};

static  WORD RSIB6MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB6DATA[] =
{ 0x0000, 0x07E0, 0x1FF8, 0x3FFC, 
  0x2FF4, 0x47E2, 0x43C2, 0x4182, 
  0x4182, 0x43C2, 0x47E2, 0x2FF4, 
  0x3FFC, 0x1FF8, 0x07E0, 0x0000
};

static  WORD RSIB7MASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RSIB7DATA[] =
{ 0x0000, 0x07E0, 0x1FF8, 0x27FC, 
  0x23FC, 0x43FA, 0x41E2, 0x4182, 
  0x4182, 0x4782, 0x5FC2, 0x3FC4, 
  0x3FE4, 0x1FF8, 0x07E0, 0x0000
};

static  WORD RSIB8MASK[] =
{ 0xFF80, 0xFF80, 0xFF80, 0xFF00, 
  0xFF00, 0xFF80, 0xFF80, 0xFFE7, 
  0xE7FF, 0x01FF, 0x01FF, 0x00FF, 
  0x00FF, 0x01FF, 0x01FF, 0x01FF
};

static  WORD RSIB8DATA[] =
{ 0x0000, 0x7F00, 0x7E00, 0x7C00, 
  0x7C00, 0x7E00, 0x6700, 0x4200, 
  0x0042, 0x00E6, 0x007E, 0x003E, 
  0x003E, 0x007E, 0x00FE, 0x0000
};

static  WORD RSIB9MASK[] =
{ 0x03C0, 0x07E0, 0x0FF0, 0x1FF8, 
  0x3FFC, 0x3FFC, 0x3FFC, 0x03C0, 
  0x03C0, 0x3FFC, 0x3FFC, 0x3FFC, 
  0x1FF8, 0x0FF0, 0x07E0, 0x03C0
};

static  WORD RSIB9DATA[] =
{ 0x0000, 0x0180, 0x03C0, 0x07E0, 
  0x0FF0, 0x1FF8, 0x0180, 0x0180, 
  0x0180, 0x0180, 0x1FF8, 0x0FF0, 
  0x07E0, 0x03C0, 0x0180, 0x0000
};

static  WORD RSIB10MASK[] =
{ 0x0000, 0x0180, 0x03C0, 0x07E0, 
  0x0FF0, 0x1FF8, 0x3FFC, 0x7FFE, 
  0x7FFE, 0x07E0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x07E0, 0x0000
};

static  WORD RSIB10DATA[] =
{ 0x0000, 0x0000, 0x0180, 0x03C0, 
  0x07E0, 0x0FF0, 0x1FF8, 0x3FFC, 
  0x03C0, 0x03C0, 0x03C0, 0x03C0, 
  0x03C0, 0x03C0, 0x0000, 0x0000
};

static  WORD RSIB11MASK[] =
{ 0x0000, 0x07E0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x07E0, 0x7FFE, 
  0x7FFE, 0x3FFC, 0x1FF8, 0x0FF0, 
  0x07E0, 0x03C0, 0x0180, 0x0000
};

static  WORD RSIB11DATA[] =
{ 0x0000, 0x0000, 0x03C0, 0x03C0, 
  0x03C0, 0x03C0, 0x03C0, 0x03C0, 
  0x3FFC, 0x1FF8, 0x0FF0, 0x07E0, 
  0x03C0, 0x0180, 0x0000, 0x0000
};

static  WORD RSIB12MASK[] =
{ 0x0000, 0xFFFE, 0xFFFE, 0xFFFE, 
  0x3F0E, 0x3F6E, 0x3FE0, 0x3FE0, 
  0x3FE0, 0x3F60, 0x3F00, 0x3F00, 
  0xFFE0, 0xFFE0, 0xFFE0, 0x0000
};

static  WORD RSIB12DATA[] =
{ 0x0000, 0xFFFE, 0x8002, 0xE1FA, 
  0x210A, 0x216E, 0x21A0, 0x2020, 
  0x21A0, 0x2160, 0x2100, 0x2100, 
  0xE1E0, 0x8020, 0xFFE0, 0x0000
};

static  ICONBLK rs_iconblk[] =
{ RSIB0MASK, RSIB0DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB1MASK, RSIB1DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB2MASK, RSIB2DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB3MASK, RSIB3DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB4MASK, RSIB4DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB5MASK, RSIB5DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB6MASK, RSIB6DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB7MASK, RSIB7DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB8MASK, RSIB8DATA, "\0\000", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   5,   5,   6,   8,
  RSIB9MASK, RSIB9DATA, "\0\000", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   5,   5,   6,   8,
  RSIB10MASK, RSIB10DATA, "\0\000", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   5,   5,   6,   8,
  RSIB11MASK, RSIB11DATA, "\0", 0x1000|'\0',
    8,   8,   0,   0,  16,  16,   0,   0,   0,   8,
  RSIB12MASK, RSIB12DATA, "\0\000", 0x1000|'\0',
    0,   0,   0,   0,  16,  16,   5,  16,   6,   8
};

static  WORD RSBB0DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x1FF8, 
  0x1FF8, 0x0FF0, 0x0FF0, 0x07E0, 
  0x07E0, 0x03C0, 0x03C0, 0x0180, 
  0x0180, 0x0000, 0x0000, 0x0000
};

static  WORD RSBB1DATA[] =
{ 0x0000, 0x0000, 0x1FF8, 0x0FF0, 
  0x07E0, 0x03C0, 0x0180, 0x0000
};

static  WORD RSBB2DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0180, 
  0x0180, 0x03C0, 0x03C0, 0x07E0, 
  0x07E0, 0x0FF0, 0x0FF0, 0x1FF8, 
  0x1FF8, 0x0000, 0x0000, 0x0000
};

static  WORD RSBB3DATA[] =
{ 0x0000, 0x0000, 0x0180, 0x03C0, 
  0x07E0, 0x0FF0, 0x1FF8, 0x0000
};

static  WORD RSBB4DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0018, 
  0x0078, 0x01F8, 0x07F8, 0x1FF8, 
  0x1FF8, 0x07F8, 0x01F8, 0x0078, 
  0x0018, 0x0000, 0x0000, 0x0000
};

static  WORD RSBB5DATA[] =
{ 0x0030, 0x00F0, 0x03F0, 0x0FF0, 
  0x0FF0, 0x03F0, 0x00F0, 0x0030
};

static  WORD RSBB6DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x1800, 
  0x1E00, 0x1F80, 0x1FE0, 0x1FF8, 
  0x1FF8, 0x1FE0, 0x1F80, 0x1E00, 
  0x1800, 0x0000, 0x0000, 0x0000
};

static  WORD RSBB7DATA[] =
{ 0x0C00, 0x0F00, 0x0FC0, 0x0FF0, 
  0x0FF0, 0x0FC0, 0x0F00, 0x0C00
};

static  WORD RSBB8DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x030C, 
  0x071C, 0x0F3C, 0x1F7C, 0x3FFC, 
  0x3FFC, 0x1F7C, 0x0F3C, 0x071C, 
  0x030C, 0x0000, 0x0000, 0x0000
};

static  WORD RSBB9DATA[] =
{ 0x0000, 0x0330, 0x0770, 0x0FF0, 
  0x0FF0, 0x0770, 0x0330, 0x0000
};

static  WORD RSBB10DATA[] =
{ 0x0000, 0x0000, 0x0000, 0x30C0, 
  0x38E0, 0x3CF0, 0x3EF8, 0x3FFC, 
  0x3FFC, 0x3EF8, 0x3CF0, 0x38E0, 
  0x30C0, 0x0000, 0x0000, 0x0000
};

static  WORD RSBB11DATA[] =
{ 0x0000, 0x0CC0, 0x0EE0, 0x0FF0, 
  0x0FF0, 0x0EE0, 0x0CC0, 0x0000
};

static  BITBLK rs_bitblk[] =
{ RSBB0DATA,   2,  16,   0,   0, 0x0001,
  RSBB1DATA,   2,   8,   0,   0, 0x0001,
  RSBB2DATA,   2,  16,   0,   0, 0x0001,
  RSBB3DATA,   2,   8,   0,   0, 0x0001,
  RSBB4DATA,   2,  16,   0,   0, 0x0001,
  RSBB5DATA,   2,   8,   0,   0, 0x0001,
  RSBB6DATA,   2,  16,   0,   0, 0x0001,
  RSBB7DATA,   2,   8,   0,   0, 0x0001,
  RSBB8DATA,   2,  16,   0,   0, 0x0001,
  RSBB9DATA,   2,   8,   0,   0, 0x0001,
  RSBB10DATA,   2,  16,   0,   0, 0x0001,
  RSBB11DATA,   2,   8,   0,   0, 0x0001
};

static  WORD RS0_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS0_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x1F03, 
  0x1183, 0x1183, 0x1183, 0x1F83, 
  0x0F83, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS0_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS0_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x1F03, 
  0x1183, 0x1183, 0x1183, 0x1F83, 
  0x0F83, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS0_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS0_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xDF00, 
  0xD180, 0xD180, 0xD180, 0xDF80, 
  0xCF80, 0xC000, 0xC000, 0xC000, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS0_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS0_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x20FD, 
  0x2F7D, 0x2B7D, 0x2D7D, 0x2F7D, 
  0x307D, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x20FD, 
  0x2F7D, 0x2B7D, 0x2D7D, 0x2F7D, 
  0x307D, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x20FD, 
  0x2F7D, 0x2B7D, 0x2D7D, 0x2F7D, 
  0x307D, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0F83, 0x0D83, 0x0983, 0x0F83, 
  0x0F83, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS0_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS0_4SDATA[] =
{ 0xFFFE, 0x8000, 0xBFFC, 0xA0FC, 
  0xAF7C, 0xAB7C, 0xAD7C, 0xAF7C, 
  0xB07C, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x0000, 
  0xFFFE, 0x8000, 0xBFFC, 0xA0FC, 
  0xAF7C, 0xAB7C, 0xAD7C, 0xAF7C, 
  0xB07C, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x0000, 
  0xFFFE, 0x8000, 0xBFFC, 0xA0FC, 
  0xAF7C, 0xAB7C, 0xAD7C, 0xAF7C, 
  0xB07C, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x0000, 
  0xFFFF, 0xFFFD, 0xC001, 0xDF01, 
  0xDF01, 0xD901, 0xDB01, 0xDF01, 
  0xC001, 0xC001, 0xC001, 0xC001, 
  0xC001, 0xC001, 0x8001, 0xFFFF
};

static  WORD RS1_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS1_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x1FE3, 
  0x1023, 0x17FB, 0x140B, 0x140B, 
  0x140B, 0x140B, 0x1C0B, 0x040B, 
  0x07FB, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS1_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS1_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x1FE3, 
  0x1023, 0x17FB, 0x140B, 0x140B, 
  0x140B, 0x140B, 0x1C0B, 0x040B, 
  0x07FB, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS1_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS1_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xDFE0, 
  0xD020, 0xD038, 0xD028, 0xD028, 
  0xD028, 0xD028, 0xDFE8, 0xC408, 
  0xC7F8, 0xC000, 0xC000, 0x8000
};

static  WORD RS1_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS1_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x303D, 0x37FD, 0x340D, 0x340D, 
  0x340D, 0x340D, 0x3C0D, 0x3C0D, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x303D, 0x37FD, 0x340D, 0x340D, 
  0x340D, 0x340D, 0x3C0D, 0x3C0D, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x303D, 0x37FD, 0x340D, 0x340D, 
  0x340D, 0x340D, 0x3C0D, 0x3C0D, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x1FE3, 
  0x1023, 0x17FB, 0x140B, 0x140B, 
  0x140B, 0x140B, 0x1C0B, 0x040B, 
  0x07FB, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS1_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS1_4SDATA[] =
{ 0xFFFE, 0x8000, 0xBFFC, 0xBFFC, 
  0xB03C, 0xB03C, 0xB02C, 0xB02C, 
  0xB02C, 0xB02C, 0xBFEC, 0xBC0C, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFE, 0x8000, 0xBFFC, 0xBFFC, 
  0xB03C, 0xB03C, 0xB02C, 0xB02C, 
  0xB02C, 0xB02C, 0xBFEC, 0xBC0C, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFE, 0x8000, 0xBFFC, 0xBFFC, 
  0xB03C, 0xB03C, 0xB02C, 0xB02C, 
  0xB02C, 0xB02C, 0xBFEC, 0xBC0C, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFD, 0xC001, 0xDFE1, 
  0xD021, 0xD039, 0xD029, 0xD029, 
  0xD029, 0xD029, 0xDFE9, 0xC409, 
  0xC7F9, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS2_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS2_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0FF3, 0x07E3, 0x03C3, 
  0x0183, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS2_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS2_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0FF3, 0x07E3, 0x03C3, 
  0x0183, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS2_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS2_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xC000, 0xC000, 0xC000, 0xCFF0, 
  0xC7E0, 0xC3C0, 0xC180, 0xC000, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS2_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS2_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0FF3, 0x07E3, 0x03C3, 
  0x0183, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS2_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS2_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xC001, 0xC001, 0xC001, 0xCFF1, 
  0xC7E1, 0xC3C1, 0xC181, 0xC001, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS3_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS3_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x3FE3, 
  0x3FE3, 0x1553, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS3_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS3_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x3FE3, 
  0x3FE3, 0x1553, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS3_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS3_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xFFE0, 
  0xFFE0, 0xD420, 0xC420, 0xC420, 
  0xC420, 0xC420, 0xC7E0, 0xC000, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS3_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS3_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FE5, 0x3005, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FE5, 0x3005, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FE5, 0x3005, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x3FE3, 
  0x3FFB, 0x0FFB, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x0003, 0x0003, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS3_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS3_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFE4, 0xB424, 0xBC2C, 0xBC2C, 
  0xBC2C, 0xBC2C, 0xBFEC, 0xBE0C, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFE4, 0xB424, 0xBC2C, 0xBC2C, 
  0xBC2C, 0xBC2C, 0xBFEC, 0xBE0C, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFE4, 0xB424, 0xBC2C, 0xBC2C, 
  0xBC2C, 0xBC2C, 0xBFEC, 0xBE0C, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xFFE1, 
  0xFFF9, 0xCC39, 0xC431, 0xC431, 
  0xC431, 0xC431, 0xC7F1, 0xC1F1, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS4_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS4_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0E73, 0x0C33, 0x0813, 0x0003, 
  0x0003, 0x0813, 0x0C33, 0x0E73, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS4_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS4_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0E73, 0x0C33, 0x0813, 0x0003, 
  0x0003, 0x0813, 0x0C33, 0x0E73, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS4_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS4_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xDC38, 
  0xD818, 0xD008, 0xC000, 0xC000, 
  0xC000, 0xC000, 0xD008, 0xD818, 
  0xDC38, 0xC000, 0xC000, 0x8000
};

static  WORD RS4_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS4_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0E73, 0x0C33, 0x0813, 0x0003, 
  0x0003, 0x0813, 0x0C33, 0x0E73, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS4_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS4_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xDC39, 
  0xD819, 0xD009, 0xC001, 0xC001, 
  0xC001, 0xC001, 0xD009, 0xD819, 
  0xDC39, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS5_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x03C0, 0x07E0, 0x0FF0, 0x0FF0, 
  0x0FF0, 0x0FF0, 0x07E0, 0x03C0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS5_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x03C0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS5_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x03C0, 
  0x0420, 0x0BD0, 0x17E8, 0x1788, 
  0x1668, 0x16E8, 0x0AD8, 0x0430, 
  0x03E0, 0x0000, 0x0000, 0x0000
};

static  WORD RS5_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03D0, 0x07E8, 0x0788, 
  0x0608, 0x0608, 0x0218, 0x0430, 
  0x03E0, 0x0000, 0x0000, 0x0000
};

static  WORD RS6_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS6_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0183, 0x0183, 0x03C3, 0x03C3, 
  0x07E3, 0x07E3, 0x0FF3, 0x0FF3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS6_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS6_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0183, 0x0183, 0x03C3, 0x03C3, 
  0x07E3, 0x07E3, 0x0FF3, 0x0FF3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS6_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS6_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xC180, 0xC180, 0xC3C0, 0xC3C0, 
  0xC7E0, 0xC7E0, 0xCFF0, 0xCFF0, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS6_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS6_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0183, 0x0183, 0x03C3, 0x03C3, 
  0x07E3, 0x07E3, 0x0FF3, 0x0FF3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS6_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS6_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xC181, 0xC181, 0xC3C1, 0xC3C1, 
  0xC7E1, 0xC7E1, 0xCFF1, 0xCFF1, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS7_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS7_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0FF3, 0x0FF3, 0x07E3, 0x07E3, 
  0x03C3, 0x03C3, 0x0183, 0x0183, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS7_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS7_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0FF3, 0x0FF3, 0x07E3, 0x07E3, 
  0x03C3, 0x03C3, 0x0183, 0x0183, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS7_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS7_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xCFF0, 0xCFF0, 0xC7E0, 0xC7E0, 
  0xC3C0, 0xC3C0, 0xC180, 0xC180, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS7_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS7_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0FF3, 0x0FF3, 0x07E3, 0x07E3, 
  0x03C3, 0x03C3, 0x0183, 0x0183, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS7_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS7_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xCFF1, 0xCFF1, 0xC7E1, 0xC7E1, 
  0xC3C1, 0xC3C1, 0xC181, 0xC181, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS8_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x03C0, 0x07E0, 0x0FF0, 0x0FF0, 
  0x0FF0, 0x0FF0, 0x07E0, 0x03C0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS8_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x03C0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS8_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x03C0, 
  0x0420, 0x0BD0, 0x17E8, 0x1788, 
  0x1668, 0x16E8, 0x0AD8, 0x0430, 
  0x03E0, 0x0000, 0x0000, 0x0000
};

static  WORD RS8_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03D0, 0x07E8, 0x0788, 
  0x0608, 0x0608, 0x0218, 0x0430, 
  0x03E0, 0x0000, 0x0000, 0x0000
};

static  WORD RS9_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS9_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0033, 0x00F3, 0x03F3, 0x0FF3, 
  0x0FF3, 0x03F3, 0x00F3, 0x0033, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS9_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS9_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0033, 0x00F3, 0x03F3, 0x0FF3, 
  0x0FF3, 0x03F3, 0x00F3, 0x0033, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS9_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS9_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xC030, 0xC0F0, 0xC3F0, 0xCFF0, 
  0xCFF0, 0xC3F0, 0xC0F0, 0xC030, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS9_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS9_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0033, 0x00F3, 0x03F3, 0x0FF3, 
  0x0FF3, 0x03F3, 0x00F3, 0x0033, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS9_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS9_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xC031, 0xC0F1, 0xC3F1, 0xCFF1, 
  0xCFF1, 0xC3F1, 0xC0F1, 0xC031, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS10_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS10_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0C03, 0x0F03, 0x0FC3, 0x0FF3, 
  0x0FF3, 0x0FC3, 0x0F03, 0x0C03, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS10_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS10_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0C03, 0x0F03, 0x0FC3, 0x0FF3, 
  0x0FF3, 0x0FC3, 0x0F03, 0x0C03, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS10_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS10_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xCC00, 0xCF00, 0xCFC0, 0xCFF0, 
  0xCFF0, 0xCFC0, 0xCF00, 0xCC00, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS10_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS10_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0C03, 0x0F03, 0x0FC3, 0x0FF3, 
  0x0FF3, 0x0FC3, 0x0F03, 0x0C03, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS10_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS10_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xCC01, 0xCF01, 0xCFC1, 0xCFF1, 
  0xCFF1, 0xCFC1, 0xCF01, 0xCC01, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS11_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS11_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0403, 
  0x0E03, 0x1F13, 0x0FB3, 0x07F3, 
  0x03F3, 0x01F3, 0x03F3, 0x07F3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS11_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS11_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0403, 
  0x0E03, 0x1F13, 0x0FB3, 0x07F3, 
  0x03F3, 0x01F3, 0x03F3, 0x07F3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS11_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS11_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xC200, 0xC700, 0xCF88, 0xC7D8, 
  0xC3F8, 0xC1F8, 0xC0F8, 0xC1F8, 
  0xC3F8, 0xC000, 0xC000, 0x8000
};

static  WORD RS11_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS11_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0403, 
  0x0E03, 0x1F13, 0x0FB3, 0x07F3, 
  0x03F3, 0x01F3, 0x03F3, 0x07F3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS11_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS11_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xC201, 0xC701, 0xCF89, 0xC7D9, 
  0xC3F9, 0xC1F9, 0xC0F9, 0xC1F9, 
  0xC3F9, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS12_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS12_MDATA[] =
{ 0x0001, 0x0001, 0x3E01, 0x2201, 
  0x3E01, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS12_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS12_1CDATA[] =
{ 0x0001, 0x0001, 0x3E01, 0x2201, 
  0x3E01, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS12_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS12_1SDATA[] =
{ 0xFFFF, 0x8000, 0xBE00, 0xA200, 
  0xBE00, 0x8000, 0x8000, 0x8000
};

static  WORD RS12_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS12_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0001, 0x3E01, 0x2201, 
  0x3E01, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS12_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS12_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0xBE00, 0xA200, 
  0xBE00, 0x8000, 0x8000, 0x8000
};

static  WORD RS13_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS13_MDATA[] =
{ 0x0001, 0x1FC1, 0x1041, 0x13F9, 
  0x1E09, 0x0209, 0x03F9, 0xFFFF
};

static  WORD RS13_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS13_1CDATA[] =
{ 0x0001, 0x1FC1, 0x1041, 0x13F9, 
  0x1E09, 0x0209, 0x03F9, 0xFFFF
};

static  WORD RS13_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS13_1SDATA[] =
{ 0xFFFF, 0x9FC0, 0x9040, 0x9078, 
  0x9FC8, 0x8208, 0x83F8, 0x8000
};

static  WORD RS13_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS13_4CDATA[] =
{ 0x0000, 0x7FFF, 0x707F, 0x73FF, 
  0x7E0F, 0x7E0F, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x707F, 0x73FF, 
  0x7E0F, 0x7E0F, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x707F, 0x73FF, 
  0x7E0F, 0x7E0F, 0x7FFF, 0x7FFF, 
  0x0001, 0x1FC1, 0x1041, 0x13F9, 
  0x1E09, 0x0209, 0x03F9, 0xFFFF
};

static  WORD RS13_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS13_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xF07E, 0xF07E, 
  0xFFCE, 0xFE0E, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xF07E, 0xF07E, 
  0xFFCE, 0xFE0E, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xF07E, 0xF07E, 
  0xFFCE, 0xFE0E, 0xFFFE, 0x0000, 
  0xFFFF, 0x9FC0, 0x9040, 0x9078, 
  0x9FC8, 0x8208, 0x83F8, 0x8000
};

static  WORD RS14_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS14_MDATA[] =
{ 0x0001, 0x0001, 0x07E1, 0x03C1, 
  0x0181, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS14_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS14_1CDATA[] =
{ 0x0001, 0x0001, 0x07E1, 0x03C1, 
  0x0181, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS14_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS14_1SDATA[] =
{ 0xFFFF, 0x8000, 0x8000, 0x8000, 
  0x87E0, 0x83C0, 0x8180, 0x8000
};

static  WORD RS14_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS14_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0001, 0x07E1, 0x03C1, 
  0x0181, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS14_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS14_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0x8000, 0x87E0, 
  0x83C0, 0x8180, 0x8000, 0x8000
};

static  WORD RS15_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS15_MDATA[] =
{ 0x0001, 0x0001, 0x3FC1, 0x1541, 
  0x0001, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS15_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS15_1CDATA[] =
{ 0x0001, 0x0001, 0x3FC1, 0x1541, 
  0x0001, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS15_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS15_1SDATA[] =
{ 0xFFFF, 0x8000, 0xBFC0, 0x9440, 
  0x8440, 0x8440, 0x87C0, 0x8000
};

static  WORD RS15_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS15_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x601F, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x601F, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x601F, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0001, 0x3FC1, 0x1FE1, 
  0x0001, 0x0001, 0x0001, 0xFFFF
};

static  WORD RS15_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS15_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xE45E, 
  0xFC7E, 0xFC7E, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xE45E, 
  0xFC7E, 0xFC7E, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xE45E, 
  0xFC7E, 0xFC7E, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0xBFC0, 0x9C60, 
  0x8440, 0x8440, 0x87C0, 0x8000
};

static  WORD RS16_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS16_MDATA[] =
{ 0x0001, 0x0001, 0x0701, 0x0621, 
  0x0461, 0x00E1, 0x0001, 0xFFFF
};

static  WORD RS16_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS16_1CDATA[] =
{ 0x0001, 0x0001, 0x0701, 0x0621, 
  0x0461, 0x00E1, 0x0001, 0xFFFF
};

static  WORD RS16_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS16_1SDATA[] =
{ 0xFFFF, 0x8000, 0x9C00, 0x9808, 
  0x9018, 0x8038, 0x8000, 0x8000
};

static  WORD RS16_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS16_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0001, 0x0701, 0x0621, 
  0x0461, 0x00E1, 0x0001, 0xFFFF
};

static  WORD RS16_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS16_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0x9C00, 0x9808, 
  0x9018, 0x8038, 0x8000, 0x8000
};

static  WORD RS17_MMASK[] =
{ 0x0000, 0x03C0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x03C0, 0x0000
};

static  WORD RS17_MDATA[] =
{ 0x0000, 0x03C0, 0x07E0, 0x07A0, 
  0x0720, 0x0660, 0x03C0, 0x0000
};

static  WORD RS17_4CMASK[] =
{ 0x0000, 0x03C0, 0x07E0, 0x0F90, 
  0x0E70, 0x06D0, 0x03E0, 0x0000
};

static  WORD RS17_4CDATA[] =
{ 0x0000, 0x0000, 0x03C0, 0x0600, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x03C0, 0x0600, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x03C0, 0x0600, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x03E0, 0x0790, 
  0x0610, 0x0610, 0x03E0, 0x0000
};

static  WORD RS18_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS18_MDATA[] =
{ 0x0001, 0x0001, 0x0181, 0x03C1, 
  0x07E1, 0x0FF1, 0x0001, 0xFFFF
};

static  WORD RS18_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS18_1CDATA[] =
{ 0x0001, 0x0001, 0x0181, 0x03C1, 
  0x07E1, 0x0FF1, 0x0001, 0xFFFF
};

static  WORD RS18_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS18_1SDATA[] =
{ 0xFFFF, 0x8000, 0x8180, 0x83C0, 
  0x87E0, 0x8FF0, 0x8000, 0x8000
};

static  WORD RS18_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS18_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0001, 0x0181, 0x03C1, 
  0x07E1, 0x0FF1, 0x0001, 0xFFFF
};

static  WORD RS18_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS18_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0x8180, 0x83C0, 
  0x87E0, 0x8FF0, 0x8000, 0x8000
};

static  WORD RS19_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS19_MDATA[] =
{ 0x0001, 0x0001, 0x0FF1, 0x07E1, 
  0x03C1, 0x0181, 0x0001, 0xFFFF
};

static  WORD RS19_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS19_1CDATA[] =
{ 0x0001, 0x0001, 0x0FF1, 0x07E1, 
  0x03C1, 0x0181, 0x0001, 0xFFFF
};

static  WORD RS19_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS19_1SDATA[] =
{ 0xFFFF, 0x8000, 0x8FF0, 0x87E0, 
  0x83C0, 0x8180, 0x8000, 0x8000
};

static  WORD RS19_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS19_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0001, 0x0FF1, 0x07E1, 
  0x03C1, 0x0181, 0x0001, 0xFFFF
};

static  WORD RS19_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS19_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0x8FF0, 0x87E0, 
  0x83C0, 0x8180, 0x8000, 0x8000
};

static  WORD RS20_MMASK[] =
{ 0x0000, 0x03C0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x03C0, 0x0000
};

static  WORD RS20_MDATA[] =
{ 0x0000, 0x03C0, 0x07E0, 0x07A0, 
  0x0720, 0x0620, 0x03C0, 0x0000
};

static  WORD RS20_4CMASK[] =
{ 0x0000, 0x03C0, 0x07E0, 0x0F90, 
  0x0E70, 0x06D0, 0x03E0, 0x0000
};

static  WORD RS20_4CDATA[] =
{ 0x0000, 0x0000, 0x03C0, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x03C0, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x03C0, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x03E0, 0x0790, 
  0x0610, 0x0610, 0x03E0, 0x0000
};

static  WORD RS21_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS21_MDATA[] =
{ 0x0001, 0x0011, 0x00F1, 0x07F1, 
  0x07F1, 0x00F1, 0x0011, 0xFFFF
};

static  WORD RS21_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS21_1CDATA[] =
{ 0x0001, 0x0011, 0x00F1, 0x07F1, 
  0x07F1, 0x00F1, 0x0011, 0xFFFF
};

static  WORD RS21_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS21_1SDATA[] =
{ 0xFFFF, 0x8010, 0x80F0, 0x87F0, 
  0x87F0, 0x80F0, 0x8010, 0x8000
};

static  WORD RS21_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS21_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0011, 0x00F1, 0x07F1, 
  0x07F1, 0x00F1, 0x0011, 0xFFFF
};

static  WORD RS21_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS21_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8010, 0x80F0, 0x87F0, 
  0x87F0, 0x80F0, 0x8010, 0x8000
};

static  WORD RS22_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS22_MDATA[] =
{ 0x0001, 0x0801, 0x0F01, 0x0FE1, 
  0x0FE1, 0x0F01, 0x0801, 0xFFFF
};

static  WORD RS22_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS22_1CDATA[] =
{ 0x0001, 0x0801, 0x0F01, 0x0FE1, 
  0x0FE1, 0x0F01, 0x0801, 0xFFFF
};

static  WORD RS22_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS22_1SDATA[] =
{ 0xFFFF, 0x8800, 0x8F00, 0x8FE0, 
  0x8FE0, 0x8F00, 0x8800, 0x8000
};

static  WORD RS22_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS22_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0801, 0x0F01, 0x0FE1, 
  0x0FE1, 0x0F01, 0x0801, 0xFFFF
};

static  WORD RS22_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS22_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8800, 0x8F00, 0x8FE0, 
  0x8FE0, 0x8F00, 0x8800, 0x8000
};

static  WORD RS23_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS23_MDATA[] =
{ 0x0001, 0x0401, 0x1F11, 0x07F1, 
  0x01F1, 0x07F1, 0x0001, 0xFFFF
};

static  WORD RS23_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS23_1CDATA[] =
{ 0x0001, 0x0401, 0x1F11, 0x07F1, 
  0x01F1, 0x07F1, 0x0001, 0xFFFF
};

static  WORD RS23_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS23_1SDATA[] =
{ 0xFFFF, 0x8000, 0x8200, 0x8F88, 
  0x83F8, 0x80F8, 0x83F8, 0x8000
};

static  WORD RS23_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS23_4CDATA[] =
{ 0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0000, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x7FFF, 0x7FFF, 0x7FFF, 0x7FFF, 
  0x0001, 0x0401, 0x1F11, 0x07F1, 
  0x01F1, 0x07F1, 0x0001, 0xFFFF
};

static  WORD RS23_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS23_4SDATA[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000, 
  0xFFFF, 0x8000, 0x8200, 0x8F88, 
  0x83F8, 0x80F8, 0x83F8, 0x8000
};

static  WORD RS24_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x03C0, 0x07E0, 0x0FF0, 0x0FF0, 
  0x0FF0, 0x0FF0, 0x07E0, 0x03C0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS24_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x03C0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS24_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x03C0, 
  0x0420, 0x0BD0, 0x17E8, 0x1788, 
  0x1668, 0x16E8, 0x0AD8, 0x0430, 
  0x03E0, 0x0000, 0x0000, 0x0000
};

static  WORD RS24_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0600, 0x0400, 
  0x0400, 0x0400, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03D0, 0x07E8, 0x0788, 
  0x0608, 0x0608, 0x0218, 0x0430, 
  0x03E0, 0x0000, 0x0000, 0x0000
};

static  WORD RS25_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS25_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0183, 0x0183, 0x03C3, 0x03C3, 
  0x07E3, 0x07E3, 0x0FF3, 0x0FF3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS25_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS25_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0183, 0x0183, 0x03C3, 0x03C3, 
  0x07E3, 0x07E3, 0x0FF3, 0x0FF3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS25_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS25_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xC180, 0xC180, 0xC3C0, 0xC3C0, 
  0xC7E0, 0xC7E0, 0xCFF0, 0xCFF0, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS25_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS25_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0183, 0x0183, 0x03C3, 0x03C3, 
  0x07E3, 0x07E3, 0x0FF3, 0x0FF3, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS25_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS25_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xC181, 0xC181, 0xC3C1, 0xC3C1, 
  0xC7E1, 0xC7E1, 0xCFF1, 0xCFF1, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS26_MMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS26_MDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0FF3, 0x0FF3, 0x07E3, 0x07E3, 
  0x03C3, 0x03C3, 0x0183, 0x0183, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS26_1CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS26_1CDATA[] =
{ 0x0001, 0x0003, 0x0003, 0x0003, 
  0x0FF3, 0x0FF3, 0x07E3, 0x07E3, 
  0x03C3, 0x03C3, 0x0183, 0x0183, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS26_1SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS26_1SDATA[] =
{ 0xFFFF, 0xFFFE, 0xC000, 0xC000, 
  0xCFF0, 0xCFF0, 0xC7E0, 0xC7E0, 
  0xC3C0, 0xC3C0, 0xC180, 0xC180, 
  0xC000, 0xC000, 0xC000, 0x8000
};

static  WORD RS26_4CMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS26_4CDATA[] =
{ 0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0001, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x3FFD, 0x3FFD, 
  0x3FFD, 0x3FFD, 0x0001, 0xFFFF, 
  0x0001, 0x0003, 0x0003, 0x0003, 
  0x0FF3, 0x0FF3, 0x07E3, 0x07E3, 
  0x03C3, 0x03C3, 0x0183, 0x0183, 
  0x0003, 0x0003, 0x7FFF, 0xFFFF
};

static  WORD RS26_4SMASK[] =
{ 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};

static  WORD RS26_4SDATA[] =
{ 0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0x8000, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0xBFFC, 0xBFFC, 
  0xBFFC, 0xBFFC, 0x8000, 0x8000, 
  0xFFFF, 0xFFFF, 0xC001, 0xC001, 
  0xCFF1, 0xCFF1, 0xC7E1, 0xC7E1, 
  0xC3C1, 0xC3C1, 0xC181, 0xC181, 
  0xC001, 0xC001, 0xC001, 0xFFFF
};

static  WORD RS27_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x1550, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x1550, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_1CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x1550, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_1CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x1550, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_1SMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x17E0, 0x07E0, 0x07E0, 
  0x07E0, 0x07E0, 0x07E0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_1SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x1420, 0x0420, 0x0420, 
  0x0420, 0x0420, 0x07E0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FF8, 0x0FF8, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FF8, 0x0FF8, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_4SMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FF8, 0x0FF8, 0x07F0, 0x07F0, 
  0x07F0, 0x07F0, 0x07F0, 0x01F0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS27_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x0420, 0x0420, 0x0420, 
  0x0420, 0x0420, 0x07E0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x0420, 0x0420, 0x0420, 
  0x0420, 0x0420, 0x07E0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FE0, 0x0420, 0x0420, 0x0420, 
  0x0420, 0x0420, 0x07E0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x3FE0, 
  0x3FF8, 0x0C38, 0x0430, 0x0430, 
  0x0430, 0x0430, 0x07F0, 0x01F0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_MMASK[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1540, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_MDATA[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1540, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_1CMASK[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1540, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_1CDATA[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1540, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_1SMASK[] =
{ 0x0000, 0x0000, 0x3FC0, 0x17C0, 
  0x07C0, 0x07C0, 0x07C0, 0x0000
};

static  WORD RS28_1SDATA[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1440, 
  0x0440, 0x0440, 0x07C0, 0x0000
};

static  WORD RS28_4CMASK[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1FE0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_4CDATA[] =
{ 0x0000, 0x0000, 0x3FC0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FC0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FC0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FC0, 0x1FE0, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS28_4SMASK[] =
{ 0x0000, 0x0000, 0x3FC0, 0x1FE0, 
  0x07C0, 0x07C0, 0x07C0, 0x0000
};

static  WORD RS28_4SDATA[] =
{ 0x0000, 0x0000, 0x3FC0, 0x0440, 
  0x0440, 0x0440, 0x07C0, 0x0000, 
  0x0000, 0x0000, 0x3FC0, 0x0440, 
  0x0440, 0x0440, 0x07C0, 0x0000, 
  0x0000, 0x0000, 0x3FC0, 0x0440, 
  0x0440, 0x0440, 0x07C0, 0x0000, 
  0x0000, 0x0000, 0x3FC0, 0x1C60, 
  0x0440, 0x0440, 0x07C0, 0x0000
};

static  WORD RS29_MMASK[] =
{ 0x0000, 0x03C0, 0x0FF0, 0x1FF8, 
  0x3FFC, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x3FFC, 
  0x1FF8, 0x0FF0, 0x03C0, 0x0000
};

static  WORD RS29_MDATA[] =
{ 0x0000, 0x03C0, 0x0C30, 0x1008, 
  0x2004, 0x2004, 0x4002, 0x4002, 
  0x4002, 0x4002, 0x2004, 0x2004, 
  0x1008, 0x0C30, 0x03C0, 0x0000
};

static  WORD RS29_1CMASK[] =
{ 0x0000, 0x03C0, 0x0FF0, 0x1FF8, 
  0x3FFC, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x3FFC, 
  0x1FF8, 0x0FF0, 0x03C0, 0x0000
};

static  WORD RS29_1CDATA[] =
{ 0x0000, 0x03C0, 0x0C30, 0x1008, 
  0x2004, 0x2004, 0x4002, 0x4002, 
  0x4002, 0x4002, 0x2004, 0x2004, 
  0x1008, 0x0C30, 0x03C0, 0x0000
};

static  WORD RS29_1SMASK[] =
{ 0x0000, 0x03C0, 0x0FF0, 0x1FF8, 
  0x3FFC, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x3FFC, 
  0x1FF8, 0x0FF0, 0x03C0, 0x0000
};

static  WORD RS29_1SDATA[] =
{ 0x0000, 0x03C0, 0x0C30, 0x1008, 
  0x23C4, 0x27E4, 0x4FF2, 0x4FF2, 
  0x4FF2, 0x4FF2, 0x27E4, 0x23C4, 
  0x1008, 0x0C30, 0x03C0, 0x0000
};

static  WORD RS29_4CMASK[] =
{ 0x0000, 0x03C0, 0x0FF0, 0x1FF8, 
  0x3FFC, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x3FFC, 
  0x1FF8, 0x0FF0, 0x03C0, 0x0000
};

static  WORD RS29_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x01E8, 
  0x07F4, 0x0FFC, 0x0FFA, 0x1FFA, 
  0x1FFA, 0x1FF2, 0x1FF4, 0x0FE4, 
  0x1788, 0x0C30, 0x03C0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x01E8, 
  0x07F4, 0x0FFC, 0x0FFA, 0x1FFA, 
  0x1FFA, 0x1FF2, 0x1FF4, 0x0FE4, 
  0x1788, 0x0C30, 0x03C0, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x01E8, 
  0x07F4, 0x0FFC, 0x0FFA, 0x1FFA, 
  0x1FFA, 0x1FF2, 0x1FF4, 0x0FE4, 
  0x1788, 0x0C30, 0x03C0, 0x0000, 
  0x0000, 0x03C0, 0x0C30, 0x1008, 
  0x200C, 0x2004, 0x4006, 0x4006, 
  0x4006, 0x400E, 0x200C, 0x201C, 
  0x1878, 0x0FF0, 0x03C0, 0x0000
};

static  WORD RS29_4SMASK[] =
{ 0x0000, 0x03C0, 0x0FF0, 0x1FF8, 
  0x3FFC, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x3FFC, 0x3FFC, 
  0x1FF8, 0x0FF0, 0x03C0, 0x0000
};

static  WORD RS29_4SDATA[] =
{ 0x0000, 0x03C0, 0x0C30, 0x11E8, 
  0x27F0, 0x2DB8, 0x4BD8, 0x5FF8, 
  0x5FF8, 0x5BD0, 0x3DB0, 0x2FE0, 
  0x1780, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0C30, 0x11E8, 
  0x27F0, 0x2DB8, 0x4BD8, 0x5FF8, 
  0x5FF8, 0x5BD0, 0x3DB0, 0x2FE0, 
  0x1780, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0C30, 0x11E8, 
  0x27F0, 0x2DB8, 0x4BD8, 0x5FF8, 
  0x5FF8, 0x5BD0, 0x3DB0, 0x2FE0, 
  0x1780, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x03C0, 0x0FF0, 0x1E18, 
  0x3804, 0x33C4, 0x77E2, 0x67E2, 
  0x67E2, 0x67E2, 0x23C4, 0x3004, 
  0x1008, 0x0C30, 0x03C0, 0x0000
};

static  WORD RS30_MMASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0xFFFF, 
  0xFFFF, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RS30_MDATA[] =
{ 0x0FF0, 0x381C, 0x6006, 0xC003, 
  0xC003, 0x6006, 0x381C, 0x0FF0
};

static  WORD RS30_1CMASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0xFFFF, 
  0xFFFF, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RS30_1CDATA[] =
{ 0x0FF0, 0x381C, 0x6006, 0xC003, 
  0xC003, 0x6006, 0x381C, 0x0FF0
};

static  WORD RS30_1SMASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0xFFFF, 
  0xFFFF, 0x7FFE, 0x3FFC, 0x0FF0
};

static  WORD RS30_1SDATA[] =
{ 0x0FF0, 0x381C, 0x63C6, 0xCFF3, 
  0xCFF3, 0x63C6, 0x381C, 0x0FF0
};

static  WORD RS30_4CMASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x3FFC, 0x0FF0, 0x0000
};

static  WORD RS30_4CDATA[] =
{ 0x0030, 0x00EC, 0x0FFA, 0x1FFA, 
  0x0FF2, 0x078C, 0x0FF0, 0x0000, 
  0x0030, 0x00EC, 0x0FFA, 0x1FFA, 
  0x0FF2, 0x078C, 0x0FF0, 0x0000, 
  0x0030, 0x00EC, 0x0FFA, 0x1FFA, 
  0x0FF2, 0x078C, 0x0FF0, 0x0000, 
  0x0FF0, 0x301C, 0x4006, 0x4006, 
  0x400E, 0x307C, 0x0FF0, 0x0000
};

static  WORD RS30_4SMASK[] =
{ 0x0FF0, 0x3FFC, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x3FFC, 0x0FF0, 0x0000
};

static  WORD RS30_4SDATA[] =
{ 0x0FF0, 0x33E0, 0x4DB0, 0x5BD8, 
  0x5DB0, 0x3700, 0x0C00, 0x0000, 
  0x0FF0, 0x33E0, 0x4DB0, 0x5BD8, 
  0x5DB0, 0x3700, 0x0C00, 0x0000, 
  0x0FF0, 0x33E0, 0x4DB0, 0x5BD8, 
  0x5DB0, 0x3700, 0x0C00, 0x0000, 
  0x0FF0, 0x3C0C, 0x73C2, 0x67E2, 
  0x63C2, 0x380C, 0x0FF0, 0x0000
};

static  WORD RS31_MMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_MDATA[] =
{ 0xFFFE, 0x8006, 0x8006, 0x8006, 
  0x8006, 0x8006, 0x8006, 0x8006, 
  0x8006, 0x8006, 0x8006, 0x8006, 
  0x8006, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_1CMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_1CDATA[] =
{ 0xFFFE, 0x8006, 0x8006, 0x8006, 
  0x8006, 0x8006, 0x8006, 0x8006, 
  0x8006, 0x8006, 0x8006, 0x8006, 
  0x8006, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_1SMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_1SDATA[] =
{ 0xFFFE, 0xFFFE, 0xC002, 0xD832, 
  0xDC72, 0xCEE2, 0xC7C2, 0xC382, 
  0xC7C2, 0xCEE2, 0xDC72, 0xD832, 
  0xC002, 0xC002, 0xFFFE, 0x0000
};

static  WORD RS31_4CMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_4CDATA[] =
{ 0x0002, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0xFFFE, 0x0000, 
  0x0002, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0xFFFE, 0x0000, 
  0x0002, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0xFFFE, 0x0000, 
  0x0002, 0x0002, 0x0002, 0x0002, 
  0x0002, 0x0002, 0x0002, 0x0002, 
  0x0002, 0x0002, 0x0002, 0x0002, 
  0x0002, 0x0002, 0xFFFE, 0x0000
};

static  WORD RS31_4SMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0x0000
};

static  WORD RS31_4SDATA[] =
{ 0xFFFE, 0xFFFC, 0xFFFC, 0xEBAC, 
  0xFD7C, 0xEEEC, 0xF7DC, 0xFBBC, 
  0xF7DC, 0xEEEC, 0xFD7C, 0xEBAC, 
  0xFFFC, 0xFFFC, 0x8000, 0x0000, 
  0xFFFE, 0xFFFC, 0xFFFC, 0xEBAC, 
  0xFD7C, 0xEEEC, 0xF7DC, 0xFBBC, 
  0xF7DC, 0xEEEC, 0xFD7C, 0xEBAC, 
  0xFFFC, 0xFFFC, 0x8000, 0x0000, 
  0xFFFE, 0xFFFC, 0xFFFC, 0xEBAC, 
  0xFD7C, 0xEEEC, 0xF7DC, 0xFBBC, 
  0xF7DC, 0xEEEC, 0xFD7C, 0xEBAC, 
  0xFFFC, 0xFFFC, 0x8000, 0x0000, 
  0xFFFE, 0x8000, 0x8000, 0x9C70, 
  0x9EF0, 0x8FE0, 0x87C0, 0x87C0, 
  0x8FE0, 0x9EF0, 0x9C70, 0x8820, 
  0x8000, 0x8000, 0x8000, 0x0000
};

static  WORD RS32_MMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE
};

static  WORD RS32_MDATA[] =
{ 0xFFFE, 0x8006, 0x8006, 0x8006, 
  0x8006, 0x8006, 0x8006, 0xFFFE
};

static  WORD RS32_1CMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE
};

static  WORD RS32_1CDATA[] =
{ 0xFFFE, 0x8006, 0x8006, 0x8006, 
  0x8006, 0x8006, 0x8006, 0xFFFE
};

static  WORD RS32_1SMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE
};

static  WORD RS32_1SDATA[] =
{ 0xFFFE, 0xC002, 0xDC72, 0xC7C2, 
  0xC7C2, 0xDC72, 0xC002, 0xFFFE
};

static  WORD RS32_4CMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE
};

static  WORD RS32_4CDATA[] =
{ 0x0002, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0xFFFE, 
  0x0002, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0xFFFE, 
  0x0002, 0x7FFE, 0x7FFE, 0x7FFE, 
  0x7FFE, 0x7FFE, 0x7FFE, 0xFFFE, 
  0x0002, 0x0002, 0x0002, 0x0002, 
  0x0002, 0x0002, 0x0002, 0xFFFE
};

static  WORD RS32_4SMASK[] =
{ 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 
  0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE
};

static  WORD RS32_4SDATA[] =
{ 0xFFFE, 0xFFFC, 0xFFFC, 0xFFFC, 
  0xFFFC, 0xFFFC, 0xFFFC, 0x8000, 
  0xFFFE, 0xFFFC, 0xFFFC, 0xFFFC, 
  0xFFFC, 0xFFFC, 0xFFFC, 0x8000, 
  0xFFFE, 0xFFFC, 0xFFFC, 0xFFFC, 
  0xFFFC, 0xFFFC, 0xFFFC, 0x8000, 
  0xFFFE, 0x8000, 0x9C70, 0x87C0, 
  0x87C0, 0x9C70, 0x8000, 0x8000
};

static  WORD RS33_MMASK[] =
{ 0x0001, 0xC000, 0x0003, 0xF000, 
  0x0003, 0xF800, 0x003F, 0xFF80, 
  0x073F, 0xFFE0, 0x07FF, 0xFFFE, 
  0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0x1FFF, 0xFFFF, 
  0x0FFF, 0xFFFC, 0x0FFF, 0xFFFC, 
  0x0FFF, 0xFFFE, 0x07FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x03FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x03FF, 0xFFFE, 
  0x03FF, 0xFFFF, 0x07FF, 0xFFFF, 
  0x07FF, 0xFFFF, 0x07FF, 0xFFFF, 
  0x07FF, 0xFFFF, 0x07FF, 0xFFFF, 
  0x07FF, 0xFFFF, 0x07FF, 0xFFFE, 
  0x01FF, 0xFC1C, 0x007F, 0xF800
};

static  WORD RS33_MDATA[] =
{ 0x0001, 0xC000, 0x0002, 0x3000, 
  0x0002, 0x0800, 0x0004, 0x0400, 
  0x0018, 0x0700, 0x0218, 0x02C0, 
  0x03F8, 0x057C, 0x63F8, 0x02AB, 
  0xFFF8, 0x0555, 0xFFF8, 0x02AA, 
  0xFFF8, 0x0556, 0x7FF8, 0x02AA, 
  0x0FF8, 0x0556, 0x03F8, 0x02A8, 
  0x07F8, 0x0558, 0x07F8, 0x02A8, 
  0x03F8, 0x0550, 0x01F8, 0x02B4, 
  0x01F8, 0x055C, 0x01F8, 0x02AC, 
  0x01F8, 0x0554, 0x01F8, 0x02AC, 
  0x01F8, 0x0554, 0x01F8, 0x02AE, 
  0x03F8, 0x0554, 0x03F8, 0x02AF, 
  0x03F8, 0x0555, 0x03F8, 0x03EA, 
  0x03F8, 0x1CBC, 0x00F8, 0x3808, 
  0x003E, 0x7000, 0x0001, 0xF000
};

static  WORD RS33_4CMASK[] =
{ 0x0001, 0xC000, 0x0003, 0xF000, 
  0x0003, 0xF800, 0x003F, 0xFF80, 
  0x073F, 0xFFE0, 0x07FF, 0xFFFE, 
  0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
  0xFFFF, 0xFFFF, 0x1FFF, 0xFFFF, 
  0x0FFF, 0xFFFC, 0x0FFF, 0xFFFC, 
  0x0FFF, 0xFFFE, 0x07FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x03FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x03FF, 0xFFFE, 
  0x03FF, 0xFFFF, 0x07FF, 0xFFFF, 
  0x07FF, 0xFFFF, 0x07FF, 0xFFFF, 
  0x07FF, 0xFFFF, 0x07FF, 0xFFFF, 
  0x07FF, 0xFFFF, 0x07FF, 0xFFFE, 
  0x01FF, 0xFC1C, 0x007F, 0xF800
};

static  WORD RS33_4CDATA[] =
{ 0x0001, 0xC000, 0x0002, 0x2000, 
  0x0002, 0x0800, 0x0004, 0x0400, 
  0x0000, 0x0600, 0x0000, 0x07C0, 
  0x0000, 0x07FC, 0x0000, 0x07FC, 
  0x0000, 0x07F8, 0x0000, 0x07F8, 
  0x0000, 0x07F8, 0x0000, 0x07F8, 
  0x0000, 0x07E0, 0x0000, 0x07E0, 
  0x0000, 0x07E0, 0x0000, 0x07C0, 
  0x0000, 0x07D0, 0x0000, 0x07F0, 
  0x0000, 0x07F0, 0x0000, 0x07F0, 
  0x0000, 0x07F0, 0x0000, 0x07F0, 
  0x0000, 0x07F8, 0x0000, 0x07F0, 
  0x0000, 0x07FC, 0x0000, 0x07FC, 
  0x0000, 0x07F8, 0x0000, 0x02F0, 
  0x0000, 0x0020, 0x0000, 0x0000, 
  0x0002, 0x0000, 0x0001, 0x0000, 
  0x0001, 0xC000, 0x0002, 0x2000, 
  0x0002, 0x0800, 0x0004, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0002, 0x0000, 0x0001, 0x0000, 
  0x0001, 0xC000, 0x0002, 0x2000, 
  0x0002, 0x0800, 0x0004, 0x0000, 
  0x0018, 0x0000, 0x0218, 0x0000, 
  0x03F8, 0x0000, 0x63F8, 0x0000, 
  0xEFF8, 0x0000, 0xFFF8, 0x0000, 
  0xFFF8, 0x0000, 0x3FF8, 0x0000, 
  0x0FF8, 0x0000, 0x03F8, 0x0000, 
  0x07F8, 0x0000, 0x07F8, 0x0000, 
  0x03F8, 0x0000, 0x01F8, 0x0000, 
  0x01F8, 0x0000, 0x01F8, 0x0000, 
  0x01F8, 0x0000, 0x01F8, 0x0000, 
  0x01F8, 0x0000, 0x01F8, 0x0000, 
  0x03F8, 0x0000, 0x03F8, 0x0000, 
  0x03F8, 0x0000, 0x03F8, 0x0000, 
  0x03F8, 0x0000, 0x00F8, 0x0000, 
  0x0002, 0x0000, 0x0001, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x1000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0100, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0003, 
  0x1000, 0x0007, 0x0000, 0x0006, 
  0x0000, 0x0006, 0x4000, 0x0006, 
  0x0000, 0x001E, 0x0000, 0x0018, 
  0x0000, 0x0018, 0x0000, 0x0038, 
  0x0000, 0x0020, 0x0000, 0x0004, 
  0x0000, 0x000C, 0x0000, 0x000C, 
  0x0000, 0x000C, 0x0000, 0x000C, 
  0x0000, 0x0004, 0x0000, 0x000E, 
  0x0000, 0x0000, 0x0000, 0x0003, 
  0x0000, 0x0007, 0x0000, 0x050E, 
  0x0000, 0x1C9C, 0x0000, 0x3808, 
  0x003C, 0x7000, 0x0000, 0xF000
};

static  WORD RS34_MMASK[] =
{ 0x01FF, 0x0000, 0x01FF, 0x0000, 
  0x01FF, 0x0000, 0x01FF, 0xC000, 
  0x01FF, 0xC000, 0x03FF, 0xC000, 
  0x03FF, 0xC000, 0x03FF, 0xC000, 
  0x01FF, 0x8000, 0x00FF, 0x8000, 
  0x00FF, 0xE000, 0x00FF, 0xE000, 
  0x01FF, 0xE000, 0x01FF, 0xF000, 
  0x01FF, 0xF800, 0x007F, 0xFC00, 
  0x003F, 0xFC00, 0x007F, 0xFC00, 
  0x007F, 0xFF00, 0x007F, 0xFF00, 
  0x007F, 0xFFE0, 0x00FF, 0xFFE0, 
  0x00FF, 0xFFE0, 0x01FF, 0xFFE0, 
  0x01FF, 0xFFE0, 0x01FF, 0xFFC0, 
  0x00FF, 0xFFE0, 0x007F, 0xFFE0, 
  0x01FF, 0xFFE0, 0x01FF, 0xFFC0, 
  0x01FF, 0xF000, 0x01FE, 0x0000
};

static  WORD RS34_MDATA[] =
{ 0x0078, 0x0000, 0x00FE, 0x0000, 
  0x007C, 0x0000, 0x00F4, 0x0000, 
  0x00F5, 0x8000, 0x00F5, 0x8000, 
  0x01F7, 0x8000, 0x00F7, 0x0000, 
  0x0076, 0x0000, 0x0036, 0x0000, 
  0x0075, 0x0000, 0x0075, 0xC000, 
  0x0075, 0xC000, 0x00F5, 0xC000, 
  0x0035, 0xE000, 0x0015, 0xD000, 
  0x0015, 0xB800, 0x0015, 0x5800, 
  0x0024, 0xB800, 0x0015, 0x7E00, 
  0x0024, 0x0C00, 0x003F, 0xFFC0, 
  0x0044, 0x00C0, 0x0055, 0x7FC0, 
  0x00A4, 0xBF80, 0x0055, 0x5F00, 
  0x0035, 0xAF00, 0x0015, 0xD7C0, 
  0x0035, 0xFF80, 0x00FF, 0xE000, 
  0x00BC, 0x0000, 0x0020, 0x0000
};

static  WORD RS34_4CMASK[] =
{ 0x0078, 0x0000, 0x00FE, 0x0000, 
  0x007C, 0x0000, 0x00F4, 0x0000, 
  0x00F5, 0x8000, 0x00F5, 0x8000, 
  0x01F7, 0x8000, 0x00F7, 0x0000, 
  0x0076, 0x0000, 0x0036, 0x0000, 
  0x0075, 0x0000, 0x0075, 0xC000, 
  0x0075, 0xC000, 0x00F5, 0xC000, 
  0x0035, 0xE000, 0x0015, 0xD000, 
  0x0015, 0xB800, 0x0015, 0x5800, 
  0x0024, 0xB800, 0x0015, 0x7E00, 
  0x0024, 0x0C00, 0x003F, 0xFFC0, 
  0x0044, 0x00C0, 0x0055, 0x7FC0, 
  0x00A4, 0xBF80, 0x0055, 0x5F00, 
  0x0035, 0xAF00, 0x0015, 0xD7C0, 
  0x0035, 0xFF80, 0x00FF, 0xE000, 
  0x00BC, 0x0000, 0x0020, 0x0000
};

static  WORD RS34_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0004, 0x0000, 
  0x0004, 0x0000, 0x0004, 0x0000, 
  0x0004, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0004, 0x0000, 
  0x0004, 0x0000, 0x0004, 0x0000, 
  0x0004, 0x0000, 0x0004, 0x0000, 
  0x0004, 0x0000, 0x0004, 0x0000, 
  0x0004, 0x2000, 0x0004, 0x4000, 
  0x0024, 0x8000, 0x0015, 0x0000, 
  0x0024, 0x0000, 0x003F, 0xFF00, 
  0x0044, 0x0000, 0x0015, 0x0000, 
  0x0024, 0x8000, 0x0044, 0x4000, 
  0x0004, 0x2000, 0x0004, 0x1000, 
  0x0004, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0020, 0x0000, 0x0000, 0x0000, 
  0x0040, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0078, 0x0000, 0x00F0, 0x0000, 
  0x0060, 0x0000, 0x00F0, 0x0000, 
  0x00F0, 0x0000, 0x00F0, 0x0000, 
  0x01F0, 0x0000, 0x00F0, 0x0000, 
  0x0070, 0x0000, 0x0030, 0x0000, 
  0x0071, 0x0000, 0x0071, 0x0000, 
  0x0071, 0x0000, 0x00E1, 0x8000, 
  0x0001, 0xC000, 0x0011, 0xC000, 
  0x0011, 0x8000, 0x0011, 0x0000, 
  0x0000, 0x3800, 0x0000, 0x7800, 
  0x0020, 0x0000, 0x0000, 0x0000, 
  0x0040, 0x0000, 0x0040, 0x7E00, 
  0x0080, 0x3C00, 0x0011, 0x1C00, 
  0x0031, 0x8F00, 0x0011, 0xC600, 
  0x0031, 0x8000, 0x00F0, 0x0000, 
  0x0080, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000E, 0x0000, 
  0x001C, 0x0000, 0x0000, 0x0000, 
  0x0001, 0x8000, 0x0001, 0x8000, 
  0x0003, 0x8000, 0x0007, 0x0000, 
  0x0006, 0x0000, 0x0002, 0x0000, 
  0x0000, 0x0000, 0x0000, 0xC000, 
  0x0000, 0xC000, 0x0010, 0x4000, 
  0x0030, 0x2000, 0x0000, 0x1000, 
  0x0000, 0x1800, 0x0000, 0x1800, 
  0x0000, 0x0000, 0x0000, 0x0600, 
  0x0000, 0x0C00, 0x0000, 0x00C0, 
  0x0000, 0x00C0, 0x0000, 0x01C0, 
  0x0000, 0x0380, 0x0000, 0x0300, 
  0x0000, 0x0000, 0x0000, 0x01C0, 
  0x0000, 0x7F80, 0x000F, 0xE000, 
  0x003C, 0x0000, 0x0020, 0x0000
};

static  WORD RS35_MMASK[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_MDATA[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x4000, 0x0002, 0x5FFF, 0xFFFA, 
  0x5FFF, 0xFFFA, 0x5FFF, 0xFFFA, 
  0x5C00, 0x003A, 0x5DFF, 0xFFBA, 
  0x5D07, 0xFFBA, 0x5D07, 0xFFBA, 
  0x5D37, 0xFFBA, 0x5D37, 0xFFBA, 
  0x5D07, 0xFFBA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xFFBA, 0x5DFF, 0x7FBA, 
  0x5DFE, 0x7FBA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xEFBA, 0x5DFF, 0xCFBA, 
  0x5DFF, 0xFFBA, 0x5DFF, 0xFDBA, 
  0x5DFF, 0xF9BA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xFFBA, 0x5C00, 0x003A, 
  0x5FFF, 0xFFFA, 0x5FFF, 0xFFFA, 
  0x5FFF, 0xFFFA, 0x4000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_4CMASK[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0002, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1F07, 0xFFBA, 0x1F07, 0xFFBA, 
  0x1F37, 0xFFBA, 0x1F37, 0xFFBA, 
  0x1F07, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0x7FBA, 
  0x1FFE, 0x7FBA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xEFBA, 0x1FFF, 0xCFBA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFDBA, 
  0x1FFF, 0xF9BA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1C00, 0x003A, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x0000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0002, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1F07, 0xFFBA, 0x1F07, 0xFFBA, 
  0x1F37, 0xFFBA, 0x1F37, 0xFFBA, 
  0x1F07, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0x7FBA, 
  0x1FFE, 0x7FBA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xEFBA, 0x1FFF, 0xCFBA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFDBA, 
  0x1FFF, 0xF9BA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1C00, 0x003A, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x0000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0002, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1F07, 0xFFBA, 0x1F07, 0xFFBA, 
  0x1F37, 0xFFBA, 0x1F37, 0xFFBA, 
  0x1F07, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0x7FBA, 
  0x1FFE, 0x7FBA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xEFBA, 0x1FFF, 0xCFBA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFDBA, 
  0x1FFF, 0xF9BA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1C00, 0x003A, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x0000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0006, 0x0000, 0x0006, 
  0x0000, 0x0006, 0x0000, 0x0006, 
  0x03FF, 0xFFC6, 0x0200, 0x0006, 
  0x0204, 0x0006, 0x020C, 0x0006, 
  0x020C, 0x0006, 0x020C, 0x0006, 
  0x027C, 0x0006, 0x02FC, 0x0006, 
  0x0200, 0x0006, 0x0201, 0x8006, 
  0x0201, 0x0006, 0x0200, 0x0006, 
  0x0200, 0x3006, 0x0200, 0x2006, 
  0x0200, 0x0006, 0x0200, 0x0606, 
  0x0200, 0x0406, 0x0200, 0x0006, 
  0x0200, 0x0006, 0x0200, 0x0006, 
  0x0000, 0x0006, 0x0000, 0x0006, 
  0x0000, 0x0006, 0x3FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_4SMASK[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0002, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1F00, 0x01BA, 0x1F00, 0x01BA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F00, 0x01BA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1C00, 0x003A, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x0000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0002, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1F00, 0x01BA, 0x1F00, 0x01BA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F00, 0x01BA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1C00, 0x003A, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x0000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0002, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFBA, 0x1FFF, 0xFFBA, 
  0x1F00, 0x01BA, 0x1F00, 0x01BA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F3F, 0xFDBA, 0x1F3F, 0xFDBA, 
  0x1F00, 0x01BA, 0x1FFF, 0xFFBA, 
  0x1FFF, 0xFFBA, 0x1C00, 0x003A, 
  0x1FFF, 0xFFFA, 0x1FFF, 0xFFFA, 
  0x1FFF, 0xFFFA, 0x0000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x0006, 0x0000, 0x0006, 
  0x0000, 0x0006, 0x0000, 0x0006, 
  0x03FF, 0xFFC6, 0x0200, 0x0006, 
  0x0200, 0x0106, 0x0200, 0x0306, 
  0x0200, 0x0306, 0x0200, 0x0306, 
  0x0200, 0x0306, 0x0200, 0x0306, 
  0x0200, 0x0306, 0x0200, 0x0306, 
  0x0200, 0x0306, 0x0200, 0x0306, 
  0x0200, 0x0306, 0x0200, 0x0306, 
  0x0200, 0x0306, 0x0200, 0x0306, 
  0x027F, 0xFF06, 0x02FF, 0xFF06, 
  0x0200, 0x0006, 0x0200, 0x0006, 
  0x0000, 0x0006, 0x0000, 0x0006, 
  0x0000, 0x0006, 0x3FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_1CMASK[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_1CDATA[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x4000, 0x0002, 0x5FFF, 0xFFFA, 
  0x5FFF, 0xFFFA, 0x5FFF, 0xFFFA, 
  0x5C00, 0x003A, 0x5DFF, 0xFFBA, 
  0x5D07, 0xFFBA, 0x5D07, 0xFFBA, 
  0x5D37, 0xFFBA, 0x5D37, 0xFFBA, 
  0x5D07, 0xFFBA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xFFBA, 0x5DFF, 0x7FBA, 
  0x5DFE, 0x7FBA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xEFBA, 0x5DFF, 0xCFBA, 
  0x5DFF, 0xFFBA, 0x5DFF, 0xFDBA, 
  0x5DFF, 0xF9BA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xFFBA, 0x5C00, 0x003A, 
  0x5FFF, 0xFFFA, 0x5FFF, 0xFFFA, 
  0x5FFF, 0xFFFA, 0x4000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_1SMASK[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS35_1SDATA[] =
{ 0x0000, 0x0000, 0x7FFF, 0xFFFE, 
  0x4000, 0x0002, 0x5FFF, 0xFFFA, 
  0x5FFF, 0xFFFA, 0x5FFF, 0xFFFA, 
  0x5C00, 0x003A, 0x5DFF, 0xFFBA, 
  0x5D00, 0x01BA, 0x5D00, 0x01BA, 
  0x5D3F, 0xFDBA, 0x5D3F, 0xFDBA, 
  0x5D3F, 0xFDBA, 0x5D3F, 0xFDBA, 
  0x5D3F, 0xFDBA, 0x5D3F, 0xFDBA, 
  0x5D3F, 0xFDBA, 0x5D3F, 0xFDBA, 
  0x5D3F, 0xFDBA, 0x5D3F, 0xFDBA, 
  0x5D3F, 0xFDBA, 0x5D3F, 0xFDBA, 
  0x5D00, 0x01BA, 0x5DFF, 0xFFBA, 
  0x5DFF, 0xFFBA, 0x5C00, 0x003A, 
  0x5FFF, 0xFFFA, 0x5FFF, 0xFFFA, 
  0x5FFF, 0xFFFA, 0x4000, 0x0002, 
  0x7FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS36_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x000F, 0xE000, 0x003F, 0xF800, 
  0x00FF, 0xFE00, 0x01FF, 0xFF00, 
  0x03FF, 0xFF80, 0x07FF, 0xFFC0, 
  0x0FFF, 0xFFE0, 0x0FFF, 0xFFE0, 
  0x1FFF, 0xFFF0, 0x1FFF, 0xFFF0, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x1FFF, 0xFFF0, 
  0x1FFF, 0xFFF0, 0x0FFF, 0xFFE0, 
  0x0FFF, 0xFFE0, 0x07FF, 0xFFC0, 
  0x03FF, 0xFF80, 0x01FF, 0xFF00, 
  0x00FF, 0xFE00, 0x003F, 0xF800, 
  0x000F, 0xE000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS36_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x000F, 0xE000, 0x003F, 0xF800, 
  0x00FF, 0xFE00, 0x01FF, 0x0F00, 
  0x03FE, 0x0780, 0x07FE, 0x07C0, 
  0x0FFF, 0x0FE0, 0x0FFF, 0xFFE0, 
  0x1FFF, 0xFFF0, 0x1FF0, 0x0FF0, 
  0x3FFC, 0x1FF8, 0x3FF8, 0x1FF8, 
  0x3FF8, 0x3FF8, 0x3FF0, 0x3FF8, 
  0x3FF0, 0x7FF8, 0x3FE0, 0x7FF8, 
  0x3FE0, 0xFFF8, 0x1FC0, 0xFFF0, 
  0x1FC1, 0xFFF0, 0x0FC1, 0xFFE0, 
  0x0FC1, 0xFFE0, 0x07E0, 0xBFC0, 
  0x03F8, 0x7F80, 0x01FF, 0xFF00, 
  0x00FF, 0xFE00, 0x003F, 0xF800, 
  0x000F, 0xE000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS36_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0xFF00, 0x03FF, 0xFF80, 
  0x07FF, 0xFFC0, 0x0FFF, 0xFFE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FFF, 0xFFF0, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x1FFF, 0xFFF0, 0x1FFF, 0xFFF0, 
  0x0FFF, 0xFFE0, 0x0FFF, 0xFFE0, 
  0x07FF, 0xFFC0, 0x03FF, 0xFF80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS36_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0x0F00, 0x03FE, 0x0780, 
  0x07FE, 0x07C0, 0x0FFF, 0x0FE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FF0, 0x0FF0, 0x3FFC, 0x1FF8, 
  0x3FF8, 0x1FF8, 0x3FF8, 0x3FF8, 
  0x3FF0, 0x3FF8, 0x3FF0, 0x7FF8, 
  0x3FE0, 0x7FF8, 0x3FE0, 0xFFF8, 
  0x1FC0, 0xFFF0, 0x1FC1, 0xFFF0, 
  0x0FC1, 0xFFE0, 0x0FC1, 0xFFE0, 
  0x07E0, 0xBFC0, 0x03F8, 0x7F80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0x0F00, 0x03FE, 0x0780, 
  0x07FE, 0x07C0, 0x0FFF, 0x0FE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FF0, 0x0FF0, 0x3FFC, 0x1FF8, 
  0x3FF8, 0x1FF8, 0x3FF8, 0x3FF8, 
  0x3FF0, 0x3FF8, 0x3FF0, 0x7FF8, 
  0x3FE0, 0x7FF8, 0x3FE0, 0xFFF8, 
  0x1FC0, 0xFFF0, 0x1FC1, 0xFFF0, 
  0x0FC1, 0xFFE0, 0x0FC1, 0xFFE0, 
  0x07E0, 0xBFC0, 0x03F8, 0x7F80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS36_4SMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0xFF00, 0x03FF, 0xFF80, 
  0x07FF, 0xFFC0, 0x0FFF, 0xFFE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FFF, 0xFFF0, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x1FFF, 0xFFF0, 0x1FFF, 0xFFF0, 
  0x0FFF, 0xFFE0, 0x0FFF, 0xFFE0, 
  0x07FF, 0xFFC0, 0x03FF, 0xFF80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS36_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0xF000, 0x0001, 0xF800, 
  0x0001, 0xF800, 0x0000, 0xF000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x000F, 0xF000, 0x0003, 0xE000, 
  0x0007, 0xE000, 0x0007, 0xC000, 
  0x000F, 0xC000, 0x000F, 0x8000, 
  0x001F, 0x8000, 0x001F, 0x0000, 
  0x003F, 0x0000, 0x003E, 0x0000, 
  0x003E, 0x0000, 0x003E, 0x0000, 
  0x001F, 0x0000, 0x0007, 0x8000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0xFF00, 0x03FF, 0xFF80, 
  0x07FF, 0xFFC0, 0x0FFF, 0xFFE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FFF, 0xFFF0, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF8, 0x3FFF, 0xFFF8, 
  0x1FFF, 0xFFF0, 0x1FFF, 0xFFF0, 
  0x0FFF, 0xFFE0, 0x0FFF, 0xFFE0, 
  0x07FF, 0xBFC0, 0x03FF, 0xFF80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0x0F00, 0x03FE, 0x0780, 
  0x07FE, 0x07C0, 0x0FFF, 0x0FE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FF0, 0x0FF0, 0x3FFC, 0x1FF8, 
  0x3FF8, 0x1FF8, 0x3FF8, 0x3FF8, 
  0x3FF0, 0x3FF8, 0x3FF0, 0x7FF8, 
  0x3FE0, 0x7FF8, 0x3FE0, 0xFFF8, 
  0x1FC0, 0xFFF0, 0x1FC1, 0xFFF0, 
  0x0FC1, 0xFFE0, 0x0FC1, 0xFFE0, 
  0x07E0, 0xFFC0, 0x03F8, 0x7F80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x000F, 0xE000, 
  0x003F, 0xF800, 0x00FF, 0xFE00, 
  0x01FF, 0x0F00, 0x03FE, 0x0780, 
  0x07FE, 0x07C0, 0x0FFF, 0x0FE0, 
  0x0FFF, 0xFFE0, 0x1FFF, 0xFFF0, 
  0x1FF0, 0x0FF0, 0x3FFC, 0x1FF8, 
  0x3FF8, 0x1FF8, 0x3FF8, 0x3FF8, 
  0x3FF0, 0x3FF8, 0x3FF0, 0x7FF8, 
  0x3FE0, 0x7FF8, 0x3FE0, 0xFFF8, 
  0x1FC0, 0xFFF0, 0x1FC1, 0xFFF0, 
  0x0FC1, 0xFFE0, 0x0FC1, 0xFFE0, 
  0x07E0, 0xFFC0, 0x03F8, 0x7F80, 
  0x01FF, 0xFF00, 0x00FF, 0xFE00, 
  0x003F, 0xF800, 0x000F, 0xE000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS37_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0400, 
  0x0000, 0x0E00, 0x0000, 0x1F00, 
  0x0000, 0x3F80, 0x0000, 0x7FC0, 
  0x0000, 0xFFE0, 0x0001, 0xFFF0, 
  0x0003, 0xFFF8, 0x0007, 0xFFFC, 
  0x000F, 0xFFFC, 0x001F, 0xFFFC, 
  0x003F, 0xFFF8, 0x007F, 0xFFF8, 
  0x00FF, 0xFFE8, 0x01FF, 0xFFE8, 
  0x03FF, 0xFFA0, 0x07FF, 0xFFA0, 
  0x0FFF, 0xFE80, 0x0FFF, 0xFE80, 
  0x0FFF, 0xFA00, 0x07FF, 0xFA00, 
  0x07FF, 0xE800, 0x05FF, 0xE800, 
  0x05FF, 0xA000, 0x017F, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000
};

static  WORD RS37_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0400, 
  0x0000, 0x0A00, 0x0000, 0x1500, 
  0x0000, 0x2E80, 0x0000, 0x5F40, 
  0x0000, 0xBFA0, 0x0001, 0x67D0, 
  0x0002, 0xDBE8, 0x0005, 0xD9F4, 
  0x000B, 0xE6E4, 0x0016, 0x77CC, 
  0x002D, 0xBB98, 0x005F, 0x9F38, 
  0x00BF, 0x6E68, 0x0177, 0x6CE8, 
  0x02D5, 0x99A0, 0x05E3, 0xF3A0, 
  0x0B80, 0xE680, 0x09E3, 0xCE80, 
  0x0CD5, 0x9A00, 0x0677, 0x3A00, 
  0x073E, 0x6800, 0x059C, 0xE800, 
  0x05C9, 0xA000, 0x0163, 0xA000, 
  0x0176, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000
};

static  WORD RS37_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0400, 
  0x0000, 0x0E00, 0x0000, 0x1F00, 
  0x0000, 0x3F80, 0x0000, 0x7FC0, 
  0x0000, 0xFFE0, 0x0001, 0xFFF0, 
  0x0003, 0xFFF8, 0x0007, 0xFFFC, 
  0x000F, 0xFFFC, 0x001F, 0xFFFC, 
  0x003F, 0xFFF8, 0x007F, 0xFFF8, 
  0x00FF, 0xFFE8, 0x01FF, 0xFFE8, 
  0x03FF, 0xFFA0, 0x07FF, 0xFFA0, 
  0x0FFF, 0xFE80, 0x0FFF, 0xFE80, 
  0x0FFF, 0xFA00, 0x07FF, 0xFA00, 
  0x07FF, 0xE800, 0x05FF, 0xE800, 
  0x05FF, 0xA000, 0x017F, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000
};

static  WORD RS37_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0400, 0x0000, 0x0E00, 
  0x0000, 0x1F00, 0x0000, 0x3F80, 
  0x0000, 0x7FC0, 0x0000, 0xFFE0, 
  0x0001, 0xFFF0, 0x0003, 0xFFF8, 
  0x0007, 0xFFEC, 0x000F, 0xFFDC, 
  0x001F, 0xFFB8, 0x003F, 0xFF78, 
  0x007F, 0xFEE8, 0x00FF, 0xFDE8, 
  0x01FF, 0xFBA0, 0x03FF, 0xF7A0, 
  0x07FF, 0xEE80, 0x0DFF, 0xDE80, 
  0x0EFF, 0xBA00, 0x077F, 0x7A00, 
  0x07BE, 0xE800, 0x05DD, 0xE800, 
  0x05EB, 0xA000, 0x0177, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0400, 0x0000, 0x0E00, 
  0x0000, 0x1F00, 0x0000, 0x3F80, 
  0x0000, 0x7FC0, 0x0000, 0xFFE0, 
  0x0001, 0xFFF0, 0x0003, 0xFFF8, 
  0x0007, 0xFFEC, 0x000F, 0xFFDC, 
  0x001F, 0xFFB8, 0x003F, 0xFF78, 
  0x007F, 0xFEE8, 0x00FF, 0xFDE8, 
  0x01FF, 0xFBA0, 0x03FF, 0xF7A0, 
  0x07FF, 0xEE80, 0x0DFF, 0xDE80, 
  0x0EFF, 0xBA00, 0x077F, 0x7A00, 
  0x07BE, 0xE800, 0x05DD, 0xE800, 
  0x05EB, 0xA000, 0x0177, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0400, 0x0000, 0x0E00, 
  0x0000, 0x1F00, 0x0000, 0x3F80, 
  0x0000, 0x7FC0, 0x0000, 0xE7E0, 
  0x0001, 0xDBF0, 0x0003, 0xF9F8, 
  0x0007, 0xF6EC, 0x000E, 0x76DC, 
  0x001D, 0xB9B8, 0x003D, 0x9F78, 
  0x007E, 0x6EE8, 0x00FF, 0x7DE8, 
  0x01DD, 0xBBA0, 0x03EB, 0xF7A0, 
  0x07F7, 0xEE80, 0x0DEB, 0xDE80, 
  0x0EDD, 0xBA00, 0x077F, 0x7A00, 
  0x07BE, 0xE800, 0x05DD, 0xE800, 
  0x05EB, 0xA000, 0x0177, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0400, 
  0x0000, 0x0E00, 0x0000, 0x1F00, 
  0x0000, 0x3F80, 0x0000, 0x7FC0, 
  0x0000, 0xFFE0, 0x0001, 0xE7F0, 
  0x0003, 0xDBF8, 0x0007, 0xF9FC, 
  0x000F, 0xF6F4, 0x001E, 0x76E4, 
  0x003D, 0xB9C8, 0x007D, 0x9F98, 
  0x00FE, 0x6F28, 0x01FF, 0x7E68, 
  0x03DD, 0xBCA0, 0x07EB, 0xF9A0, 
  0x0FF7, 0xF280, 0x0BEB, 0xE680, 
  0x09DD, 0xCA00, 0x04FF, 0x9A00, 
  0x067F, 0x2800, 0x053E, 0x6800, 
  0x059C, 0xA000, 0x0149, 0xA000, 
  0x0162, 0x8000, 0x0056, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000
};

static  WORD RS37_4SMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0400, 
  0x0000, 0x0E00, 0x0000, 0x1F00, 
  0x0000, 0x3F80, 0x0000, 0x7FC0, 
  0x0000, 0xFFE0, 0x0001, 0xFFF0, 
  0x0003, 0xFFF8, 0x0007, 0xFFFC, 
  0x000F, 0xFFFC, 0x001F, 0xFFFC, 
  0x003F, 0xFFF9, 0x7FFF, 0xFFFB, 
  0x7FFF, 0xFFEE, 0x01FF, 0xFFEC, 
  0x7FFF, 0xFFA9, 0x7FFF, 0xFFA3, 
  0x0FFF, 0xFEB6, 0x0FFF, 0xFE9C, 
  0x0FFF, 0xFAC9, 0x07FF, 0xFA63, 
  0x07FF, 0xEB36, 0x05FF, 0xE99C, 
  0x05FF, 0xACC8, 0x017F, 0xA660, 
  0x017E, 0xB230, 0x005E, 0x9818, 
  0x005A, 0xCC0C, 0x0012, 0x6604, 
  0x0010, 0x2300, 0x0000, 0x0100
};

static  WORD RS37_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0400, 0x0000, 0x0E00, 
  0x0000, 0x1F00, 0x0000, 0x3F80, 
  0x0000, 0x7FC0, 0x0000, 0xFFE0, 
  0x0001, 0xFFF0, 0x0003, 0xFFF8, 
  0x0007, 0xFFEC, 0x000F, 0xFFDC, 
  0x001F, 0xFFB8, 0x003F, 0xFF78, 
  0x007F, 0xFEE8, 0x00FF, 0xFDE8, 
  0x01FF, 0xFBA0, 0x03FF, 0xF7A0, 
  0x07FF, 0xEE80, 0x0DFF, 0xDE80, 
  0x0EFF, 0xBA00, 0x077F, 0x7A00, 
  0x07BE, 0xE800, 0x05DD, 0xE800, 
  0x05EB, 0xA000, 0x0177, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0400, 0x0000, 0x0E00, 
  0x0000, 0x1F00, 0x0000, 0x3F80, 
  0x0000, 0x7FC0, 0x0000, 0xFFE0, 
  0x0001, 0xFFF0, 0x0003, 0xFFF8, 
  0x0007, 0xFFEC, 0x000F, 0xFFDC, 
  0x001F, 0xFFB9, 0x7FBF, 0xFF7B, 
  0x7F7F, 0xFEEE, 0x00FF, 0xFDEC, 
  0x7DFF, 0xFBA9, 0x7BFF, 0xF7A3, 
  0x07FF, 0xEEB6, 0x0DFF, 0xDE9C, 
  0x0EFF, 0xBAC9, 0x077F, 0x7A63, 
  0x07BE, 0xEB36, 0x05DD, 0xE99C, 
  0x05EB, 0xACC8, 0x0177, 0xA660, 
  0x017E, 0xB230, 0x005E, 0x9818, 
  0x005A, 0xCC0C, 0x0012, 0x6604, 
  0x0010, 0x2300, 0x0000, 0x0100, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0400, 0x0000, 0x0E00, 
  0x0000, 0x1F00, 0x0000, 0x3F80, 
  0x0000, 0x7FC0, 0x0000, 0xE7E0, 
  0x0001, 0xDBF0, 0x0003, 0xF9F8, 
  0x0007, 0xF6EC, 0x000E, 0x76DC, 
  0x001D, 0xB9B8, 0x003D, 0x9F78, 
  0x007E, 0x6EE8, 0x00F7, 0x7DE8, 
  0x01D5, 0xBBA0, 0x03E3, 0xF7A0, 
  0x0780, 0xEE80, 0x0DE3, 0xDE80, 
  0x0ED5, 0xBA00, 0x0777, 0x7A00, 
  0x07BE, 0xE800, 0x05DD, 0xE800, 
  0x05EB, 0xA000, 0x0177, 0xA000, 
  0x017E, 0x8000, 0x005E, 0x8000, 
  0x005A, 0x0000, 0x0012, 0x0000, 
  0x0010, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0400, 
  0x0000, 0x0E00, 0x0000, 0x1F00, 
  0x0000, 0x3F80, 0x0000, 0x7FC0, 
  0x0000, 0xFFE0, 0x0001, 0xE7F0, 
  0x0003, 0xDBF8, 0x0007, 0xF9FC, 
  0x000F, 0xF6F4, 0x001E, 0x76E4, 
  0x003D, 0xB9C9, 0x7F7D, 0x9F9B, 
  0x7EFE, 0x6F2A, 0x01F7, 0x7E68, 
  0x7BD5, 0xBCA1, 0x77E3, 0xF9A3, 
  0x0F80, 0xF296, 0x0BE3, 0xE69C, 
  0x09D5, 0xCA49, 0x04F7, 0x9A63, 
  0x067F, 0x2936, 0x053E, 0x699C, 
  0x059C, 0xA4C8, 0x0149, 0xA660, 
  0x0162, 0x9230, 0x0056, 0x9818, 
  0x005A, 0x4C0C, 0x0012, 0x6604, 
  0x0010, 0x2300, 0x0000, 0x0100
};

static  WORD RS38_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x3FFF, 0xE000, 0x1FFF, 0xF87C, 
  0x0FFF, 0xF8FE, 0x0FFF, 0xF9FF, 
  0x0FE0, 0xFBFF, 0x0FEC, 0x7BFF, 
  0x0FFC, 0x3FFF, 0x0FFF, 0x1FFE, 
  0x0FFF, 0x07F0, 0x0FFF, 0x07F0, 
  0x0FFF, 0x0FFC, 0x0FFF, 0x1FFC, 
  0x0FE7, 0x3FFF, 0x0FE3, 0x3FFF, 
  0x0FE0, 0x1FFE, 0x0FE0, 0x1FFC, 
  0x1FE0, 0x07F0, 0x3FE0, 0x07F0, 
  0x3FF8, 0x07F0, 0x0FF8, 0x07F0, 
  0x0FF8, 0xE7F0, 0x0001, 0xF7F0, 
  0x0001, 0xF7F0, 0x0001, 0xFFF0, 
  0x0000, 0xFFE0, 0x0000, 0x7FE0, 
  0x0000, 0x3FC0, 0x0000, 0x1F80
};

static  WORD RS38_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x2000, 0x2000, 0x18FC, 0x387C, 
  0x08FF, 0x3882, 0x08FF, 0xB903, 
  0x08E0, 0xBA27, 0x08EC, 0x7A7F, 
  0x08F4, 0x3C7F, 0x08E7, 0x1C7E, 
  0x0807, 0x0470, 0x08E7, 0x0470, 
  0x08F7, 0x0C7C, 0x08FF, 0x1004, 
  0x08E7, 0x200F, 0x08E3, 0x3C7F, 
  0x08E0, 0x1C7E, 0x08E0, 0x1C7C, 
  0x18E0, 0x0470, 0x2020, 0x0470, 
  0x3FF8, 0x0470, 0x0FF8, 0x0470, 
  0x0FF8, 0xE470, 0x0001, 0x1470, 
  0x0001, 0x14F0, 0x0001, 0x18F0, 
  0x0000, 0x81E0, 0x0000, 0x7FE0, 
  0x0000, 0x3FC0, 0x0000, 0x1F80
};

static  WORD RS38_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x3FFF, 0xE000, 0x1FFF, 0xF87C, 
  0x0FFF, 0xF8FE, 0x0FFF, 0xF9FF, 
  0x0FE1, 0xFBFF, 0x0FEC, 0xFBFF, 
  0x0FFC, 0x7FFF, 0x0FFF, 0x3FFE, 
  0x0FFF, 0x1FF0, 0x0FFF, 0x07F0, 
  0x0FFF, 0x0FFC, 0x0FFF, 0x1FFC, 
  0x0FE7, 0x3FFF, 0x0FE3, 0x3FFF, 
  0x0FE0, 0x1FFE, 0x0FE0, 0x1FFC, 
  0x1FE0, 0x07F0, 0x3FE0, 0x07F0, 
  0x3FF8, 0x07F0, 0x0FF8, 0x07F0, 
  0x0FF8, 0xE7F0, 0x0001, 0xF7F0, 
  0x0001, 0xF7F0, 0x0001, 0xFFF0, 
  0x0000, 0xFFE0, 0x0000, 0x7FE0, 
  0x0000, 0x3FC0, 0x0000, 0x1F80
};

static  WORD RS38_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x2000, 0x2000, 0x18F8, 0x207C, 
  0x0886, 0x2082, 0x0881, 0x2102, 
  0x0880, 0xA204, 0x088C, 0x2278, 
  0x0894, 0x6440, 0x08E4, 0x0440, 
  0x0804, 0x0440, 0x08E4, 0x0440, 
  0x0894, 0x0C7C, 0x088C, 0x1004, 
  0x0880, 0x2008, 0x0880, 0x3C70, 
  0x0880, 0x0440, 0x0880, 0x0440, 
  0x18C0, 0x0440, 0x2020, 0x0440, 
  0x3FE0, 0x0440, 0x0000, 0x0440, 
  0x0000, 0xE440, 0x0001, 0x1440, 
  0x0001, 0x1480, 0x0001, 0x1880, 
  0x0000, 0x8100, 0x0000, 0x7E00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x2000, 0x2000, 0x18F8, 0x207C, 
  0x0886, 0x2082, 0x0881, 0x2102, 
  0x0880, 0xA204, 0x088C, 0x2278, 
  0x0894, 0x6440, 0x08E4, 0x0440, 
  0x0804, 0x0440, 0x08E4, 0x0440, 
  0x0894, 0x0C7C, 0x088C, 0x1004, 
  0x0880, 0x2008, 0x0880, 0x3C70, 
  0x0880, 0x0440, 0x0880, 0x0440, 
  0x18C0, 0x0440, 0x2020, 0x0440, 
  0x3FE0, 0x0440, 0x0000, 0x0440, 
  0x0000, 0xE440, 0x0001, 0x1440, 
  0x0001, 0x1480, 0x0001, 0x1880, 
  0x0000, 0x8100, 0x0000, 0x7E00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x2000, 0x2000, 0x18F8, 0x207C, 
  0x0886, 0x2082, 0x0881, 0x2102, 
  0x0880, 0xA204, 0x088C, 0x2278, 
  0x0894, 0x6440, 0x08E4, 0x0440, 
  0x0804, 0x0440, 0x08E4, 0x0440, 
  0x0894, 0x0C7C, 0x088C, 0x1004, 
  0x0880, 0x2008, 0x0880, 0x3C70, 
  0x0880, 0x0440, 0x0880, 0x0440, 
  0x18C0, 0x0440, 0x2020, 0x0440, 
  0x3FE0, 0x0440, 0x0000, 0x0440, 
  0x0000, 0xE440, 0x0001, 0x1440, 
  0x0001, 0x1480, 0x0001, 0x1880, 
  0x0000, 0x8100, 0x0000, 0x7E00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x3FFF, 0xE000, 
  0x2000, 0x2000, 0x18FC, 0x387C, 
  0x08FF, 0x38C6, 0x08FF, 0xB903, 
  0x08E1, 0xBB37, 0x08EC, 0xFA7F, 
  0x08F4, 0x7E7F, 0x08F7, 0x3C7E, 
  0x0807, 0x1C70, 0x08F7, 0x0470, 
  0x08F7, 0x0C7C, 0x08FF, 0x1004, 
  0x08E7, 0x200F, 0x08E3, 0x3C7F, 
  0x08E0, 0x1C7E, 0x08E0, 0x1C7C, 
  0x18E0, 0x0470, 0x2020, 0x0470, 
  0x3FF8, 0x0470, 0x0FF8, 0x0470, 
  0x0FF8, 0xE470, 0x0001, 0x94F0, 
  0x0001, 0x14F0, 0x0001, 0x19F0, 
  0x0000, 0x83E0, 0x0000, 0x7FE0, 
  0x0000, 0x3FC0, 0x0000, 0x1F80
};

static  WORD RS38_4SMASK[] =
{ 0x0000, 0x0000, 0xFFFF, 0x8000, 
  0xFFFF, 0x8000, 0x7FFF, 0x81F0, 
  0x3E1F, 0x83F8, 0x3FFF, 0xFFF8, 
  0x3FFF, 0xFFF0, 0x3FFF, 0xFFFF, 
  0x3FF1, 0xFF7F, 0x3FF0, 0x7FFF, 
  0x3FF0, 0x3FFF, 0x3FF3, 0x3FFE, 
  0x3FF7, 0x3FF0, 0x3FFF, 0x7FF0, 
  0x3FFF, 0xFFF0, 0x3FFF, 0xFFF0, 
  0x3FE7, 0x1FFF, 0x3FE3, 0x1FFF, 
  0x7FE0, 0x1FFE, 0xFFE0, 0x1FFC, 
  0xFFE0, 0x1FF0, 0x03E0, 0x1FF0, 
  0x03E3, 0x9FF0, 0x0FFF, 0xDFF0, 
  0x0FFF, 0xDFF0, 0x0007, 0xFFF0, 
  0x0003, 0xFDF0, 0x0001, 0xFDF0, 
  0x0000, 0x7DE0, 0x0000, 0x7FE0, 
  0x0000, 0x3FC0, 0x0000, 0x1F80
};

static  WORD RS38_4SDATA[] =
{ 0x0000, 0x0000, 0xFFFF, 0x8000, 
  0x8000, 0x8000, 0x63E0, 0x81F0, 
  0x2218, 0x8208, 0x2204, 0x8408, 
  0x2202, 0x8810, 0x2232, 0x89E0, 
  0x2251, 0x9100, 0x2390, 0x1100, 
  0x2010, 0x1100, 0x2390, 0x1100, 
  0x2250, 0x31F0, 0x2230, 0x4010, 
  0x2200, 0x8020, 0x2200, 0xF1C0, 
  0x2200, 0x1100, 0x2200, 0x1100, 
  0x6300, 0x1100, 0x8080, 0x1100, 
  0xFF80, 0x1100, 0x0000, 0x1100, 
  0x0003, 0x9100, 0x0004, 0x5100, 
  0x0004, 0x5200, 0x0004, 0x6200, 
  0x0002, 0x0400, 0x0001, 0xF800, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0xFFFF, 0x8000, 
  0x8000, 0x8000, 0x63E0, 0x81F0, 
  0x2218, 0x8208, 0x2204, 0x8408, 
  0x2202, 0x8810, 0x2232, 0x89E0, 
  0x2251, 0x9100, 0x2390, 0x1100, 
  0x2010, 0x1100, 0x2390, 0x1100, 
  0x2250, 0x31F0, 0x2230, 0x4010, 
  0x2200, 0x8020, 0x2200, 0xF1C0, 
  0x2200, 0x1100, 0x2200, 0x1100, 
  0x6300, 0x1100, 0x8080, 0x1100, 
  0xFF80, 0x1100, 0x0000, 0x1100, 
  0x0003, 0x9100, 0x0004, 0x5100, 
  0x0004, 0x5200, 0x0004, 0x6200, 
  0x0002, 0x0400, 0x0001, 0xF800, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0xFFFF, 0x8000, 
  0x8000, 0x8000, 0x63E0, 0x81F0, 
  0x2218, 0x8208, 0x2204, 0x8408, 
  0x2202, 0x8810, 0x2232, 0x89E0, 
  0x2251, 0x9100, 0x2390, 0x1100, 
  0x2010, 0x1100, 0x2390, 0x1100, 
  0x2250, 0x31F0, 0x2230, 0x4010, 
  0x2200, 0x8020, 0x2200, 0xF1C0, 
  0x2200, 0x1100, 0x2200, 0x1100, 
  0x6300, 0x1100, 0x8080, 0x1100, 
  0xFF80, 0x1100, 0x0000, 0x1100, 
  0x0003, 0x9100, 0x0004, 0x5100, 
  0x0004, 0x5200, 0x0004, 0x6200, 
  0x0002, 0x0400, 0x0001, 0xF800, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0xFFFF, 0x8000, 
  0x8000, 0x8000, 0x63F0, 0x81F0, 
  0x221C, 0x8318, 0x23FE, 0xFC08, 
  0x23FE, 0xF8D0, 0x23FF, 0xF9FF, 
  0x23D1, 0xF17F, 0x23D0, 0x71FF, 
  0x2010, 0x31FF, 0x23D3, 0x31FE, 
  0x23D7, 0x31F0, 0x23FF, 0x4010, 
  0x23FF, 0x8030, 0x23FF, 0xF1F0, 
  0x23E7, 0x11FF, 0x23E3, 0x11FF, 
  0x63E0, 0x11FE, 0x80E0, 0x11FC, 
  0xFFE0, 0x11F0, 0x03E0, 0x11F0, 
  0x03E3, 0x91F0, 0x0FFE, 0x51F0, 
  0x0FFC, 0x53F0, 0x0004, 0x63F0, 
  0x0002, 0x05F0, 0x0001, 0xFDF0, 
  0x0000, 0x7DE0, 0x0000, 0x7FE0, 
  0x0000, 0x3FC0, 0x0000, 0x1F80
};

static  WORD RS39_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x07FF, 0xFFFF, 0xFF00, 
  0x07FF, 0xFFFF, 0xFF00, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x00FF, 0xFFFF, 0xFFC0, 0x00FF, 
  0xFFFF, 0xFFC0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS39_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0001, 0x1100, 
  0x04C0, 0x0001, 0x3300, 0x05FF, 
  0xFFFF, 0x77C0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x0400, 0x0000, 0x01C0, 
  0x0400, 0x0000, 0x03C0, 0x0400, 
  0x0000, 0x03C0, 0x047E, 0x0000, 
  0x03C0, 0x0442, 0x3755, 0xA3C0, 
  0x0442, 0x36D7, 0x63C0, 0x0442, 
  0x0000, 0x03C0, 0x0442, 0x2D56, 
  0xA3C0, 0x047E, 0x375C, 0xA3C0, 
  0x0400, 0x0000, 0x03C0, 0x0400, 
  0x0000, 0x03C0, 0x0400, 0x0000, 
  0x03C0, 0x0400, 0x0000, 0x03C0, 
  0x0400, 0x0000, 0x03C0, 0x047F, 
  0x1FC7, 0xF3C0, 0x0441, 0x9064, 
  0x1BC0, 0x047F, 0x9FE7, 0xFBC0, 
  0x043F, 0x8FE3, 0xFBC0, 0x0400, 
  0x0000, 0x03C0, 0x05FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x00FF, 0xFFFF, 0xFFC0, 0x00FF, 
  0xFFFF, 0xFFC0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS39_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x07FF, 0xFFFF, 0xFF00, 
  0x07FF, 0xFFFF, 0xFF00, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x00FF, 0xFFFF, 0xFFC0, 0x00FF, 
  0xFFFF, 0xFFC0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS39_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0003, 0x1100, 
  0x0540, 0x0003, 0x5500, 0x047F, 
  0xFFFF, 0x1100, 0x07FF, 0xFFFF, 
  0xFF00, 0x0400, 0x0000, 0x0300, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05C3, 0xFFFF, 0xFD00, 
  0x05C3, 0xFFFF, 0xFD00, 0x05C3, 
  0xFFFF, 0xFD00, 0x05C3, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05C1, 0x705C, 
  0x1500, 0x05FF, 0x7FDF, 0xF500, 
  0x05C0, 0x701C, 0x0500, 0x05FF, 
  0xFFFF, 0xFD00, 0x0600, 0x0000, 
  0x0100, 0x07FF, 0xFFFF, 0xFF00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0003, 0x1100, 
  0x0540, 0x0003, 0x5500, 0x047F, 
  0xFFFF, 0x1100, 0x07FF, 0xFFFF, 
  0xFF00, 0x0400, 0x0000, 0x0300, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05C3, 0xFFFF, 0xFD00, 
  0x05C3, 0xFFFF, 0xFD00, 0x05C3, 
  0xFFFF, 0xFD00, 0x05C3, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05C1, 0x705C, 
  0x1500, 0x05FF, 0x7FDF, 0xF500, 
  0x05C0, 0x701C, 0x0500, 0x05FF, 
  0xFFFF, 0xFD00, 0x0600, 0x0000, 
  0x0100, 0x07FF, 0xFFFF, 0xFF00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0003, 0x1100, 
  0x0540, 0x0003, 0x5500, 0x047F, 
  0xFFFF, 0x1100, 0x07FF, 0xFFFF, 
  0xFF00, 0x0400, 0x0000, 0x0300, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05C3, 0xFFFF, 0xFD00, 
  0x05C3, 0xFFFF, 0xFD00, 0x05C3, 
  0xFFFF, 0xFD00, 0x05C3, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05C1, 0x705C, 
  0x1500, 0x05FF, 0x7FDF, 0xF500, 
  0x05C0, 0x701C, 0x0500, 0x05FF, 
  0xFFFF, 0xFD00, 0x0600, 0x0000, 
  0x0100, 0x07FF, 0xFFFF, 0xFF00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0001, 0x1100, 
  0x04C0, 0x0001, 0x3300, 0x05C0, 
  0x0001, 0x77C0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x0400, 0x0000, 0x01C0, 
  0x0400, 0x0000, 0x03C0, 0x0400, 
  0x0000, 0x03C0, 0x047E, 0x0000, 
  0x03C0, 0x0442, 0x3755, 0xA3C0, 
  0x0442, 0x36D7, 0x63C0, 0x0442, 
  0x0000, 0x03C0, 0x0442, 0x2D56, 
  0xA3C0, 0x047E, 0x375C, 0xA3C0, 
  0x0400, 0x0000, 0x03C0, 0x0400, 
  0x0000, 0x03C0, 0x0400, 0x0000, 
  0x03C0, 0x0400, 0x0000, 0x03C0, 
  0x0400, 0x0000, 0x03C0, 0x047F, 
  0x1FC7, 0xF3C0, 0x0441, 0x9064, 
  0x1BC0, 0x047F, 0x9FE7, 0xFBC0, 
  0x043F, 0x8FE3, 0xFBC0, 0x0400, 
  0x0000, 0x03C0, 0x05FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x00FF, 0xFFFF, 0xFFC0, 0x00FF, 
  0xFFFF, 0xFFC0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS39_4SMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x07FF, 0xFFFF, 0xFF00, 
  0x07FF, 0xFFFF, 0xFF00, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x07FF, 0xFFFF, 0xFFC0, 0x07FF, 
  0xFFFF, 0xFFC0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x00FF, 0xFFFF, 0xFFC0, 0x00FF, 
  0xFFFF, 0xFFC0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS39_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0001, 0x1100, 
  0x055F, 0xFFFF, 0x5500, 0x045F, 
  0xFFFF, 0x1100, 0x07FF, 0xFFFF, 
  0xFF00, 0x0400, 0x0000, 0x0300, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05C1, 0x705F, 
  0xFD00, 0x05FF, 0x7FDE, 0x0D00, 
  0x05C0, 0x701F, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x0600, 0x0000, 
  0x0100, 0x07FF, 0xFFFF, 0xFF00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0001, 0x1100, 
  0x055F, 0xFFFF, 0x5500, 0x045F, 
  0xFFFF, 0x1100, 0x07FF, 0xFFFF, 
  0xFF00, 0x0400, 0x0000, 0x0300, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05C1, 0x705F, 
  0xFD00, 0x05FF, 0x7FDF, 0xFD00, 
  0x05C0, 0x701F, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x0600, 0x0000, 
  0x0100, 0x07FF, 0xFFFF, 0xFF00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x0440, 0x0001, 0x1100, 
  0x055F, 0xFFFF, 0x5500, 0x045F, 
  0xFFFF, 0x1100, 0x07FF, 0xFFFF, 
  0xFF00, 0x0400, 0x0000, 0x0300, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05FF, 0xFFFF, 
  0xFD00, 0x05FF, 0xFFFF, 0xFD00, 
  0x05FF, 0xFFFF, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x05C1, 0x705F, 
  0xFD00, 0x05FF, 0x7FDE, 0x0D00, 
  0x05C0, 0x701F, 0xFD00, 0x05FF, 
  0xFFFF, 0xFD00, 0x0600, 0x0000, 
  0x0100, 0x07FF, 0xFFFF, 0xFF00, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x07FF, 0xFFFF, 
  0xFF00, 0x047F, 0xFFFF, 0x1100, 
  0x04FF, 0xFFFF, 0x3300, 0x05FF, 
  0xFFFF, 0x77C0, 0x07FF, 0xFFFF, 
  0xFFC0, 0x0400, 0x0000, 0x01C0, 
  0x0400, 0x0000, 0x03C0, 0x04C1, 
  0xC000, 0x03C0, 0x0467, 0x0000, 
  0x03C0, 0x043E, 0x3755, 0xA3C0, 
  0x0418, 0x36D7, 0x63C0, 0x043C, 
  0x0000, 0x03C0, 0x0464, 0x2D56, 
  0xA3C0, 0x04C6, 0x375C, 0xA3C0, 
  0x04C3, 0x0000, 0x03C0, 0x0401, 
  0x0000, 0x03C0, 0x0400, 0x0000, 
  0x03C0, 0x0400, 0x0000, 0x03C0, 
  0x0400, 0x0000, 0x03C0, 0x047F, 
  0x1FC0, 0x03C0, 0x0441, 0x9063, 
  0xFBC0, 0x047F, 0x9FE2, 0x0BC0, 
  0x043F, 0x8FE3, 0xFBC0, 0x0400, 
  0x0000, 0x03C0, 0x05FF, 0xFFFF, 
  0xFFC0, 0x07FF, 0xFFFF, 0xFFC0, 
  0x00FF, 0xFFFF, 0xFFC0, 0x00FF, 
  0xFFFF, 0xFFC0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS40_MMASK[] =
{ 0x0000, 0x0000, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x003F, 0x7800, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FF7, 0xFFFE, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x1FFF, 0xFFFC, 
  0x1FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x1FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x1FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x1FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x1FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x1FFF, 0xFFFC, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS40_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x14AE, 0x52A4, 0x14AE, 0x52A4, 
  0x14AE, 0x52A4, 0x17AB, 0xDEBC, 
  0x000A, 0x0000, 0x000A, 0x0000, 
  0x0012, 0x3000, 0x1FE2, 0x5FFC, 
  0x0002, 0x8000, 0x0003, 0x0000, 
  0x06DB, 0x6DB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS40_4CMASK[] =
{ 0x0000, 0x0000, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS40_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x14AE, 0x52A4, 0x14AE, 0x52A4, 
  0x14AE, 0x52A4, 0x17AB, 0xDEBC, 
  0x000A, 0x0000, 0x000A, 0x0000, 
  0x0012, 0x3000, 0x1FE2, 0x5FFC, 
  0x0002, 0x8000, 0x0003, 0x0000, 
  0x06DB, 0x6DB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x14AA, 0x52A4, 0x14AA, 0x52A4, 
  0x14A0, 0x52A4, 0x17A1, 0xDEBC, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x06D9, 0x6DB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x14AA, 0x52A4, 0x14AA, 0x52A4, 
  0x14A0, 0x52A4, 0x17A1, 0xDEBC, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x06D9, 0x6DB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x1329, 0x8C98, 0x14AA, 0x52A4, 
  0x14AA, 0x52A4, 0x14AA, 0x52A4, 
  0x14A4, 0x52A4, 0x1321, 0x8C98, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x06DB, 0x6DB0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS40_4SMASK[] =
{ 0x0000, 0x0000, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x3FFF, 0xFFFE, 
  0x3FFF, 0xFFFE, 0x0000, 0x0000
};

static  WORD RS40_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x16AA, 0x52A4, 0x16AA, 0x52A4, 
  0x17AA, 0x57A4, 0x17AB, 0xDFBC, 
  0x0500, 0x0500, 0x0500, 0x0500, 
  0x0918, 0x0918, 0x112F, 0xF12C, 
  0x0140, 0x0140, 0x0180, 0x0180, 
  0x07D9, 0x6DB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x14AA, 0x50A4, 0x14AA, 0x50A4, 
  0x10AA, 0x52A4, 0x12AB, 0xDABC, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x06D9, 0x6CB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x17AB, 0xDEBC, 0x14AA, 0x52A4, 
  0x14AA, 0x50A4, 0x14AA, 0x50A4, 
  0x10AA, 0x52A4, 0x12AB, 0xDABC, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x06D9, 0x6CB0, 0x0000, 0x0000, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x1329, 0x8C98, 0x14AA, 0x52A4, 
  0x14AA, 0x50A4, 0x14AA, 0x50A4, 
  0x12AA, 0x52A4, 0x1229, 0x8898, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x06DB, 0x6DB0, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0EB4, 0xD2F8, 
  0x0696, 0x9278, 0x07FF, 0xFFF8, 
  0x0FA2, 0xA5F8, 0x0FFF, 0xFFF8, 
  0x0FFF, 0xFFF8, 0x0FFF, 0xFFF8, 
  0x06DB, 0x6DB0, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000
};

static  WORD RS41_MMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF000, 0x0007, 0xFF00, 
  0x000F, 0xFFF0, 0x001F, 0xFFFF, 
  0x003F, 0xFFFF, 0x007F, 0xFFFE, 
  0x00FF, 0xFFFE, 0x01FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x07FF, 0xFFFE, 
  0x0FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x3FFF, 0xFFFC, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFF, 0x7FFF, 0xFFFF, 
  0xFFFF, 0xFFFE, 0xFFFF, 0xFFFC, 
  0xFFFF, 0xFFF8, 0xFFFF, 0xFFF8, 
  0x7FFF, 0xFFF0, 0x7FFF, 0xFFE0, 
  0x7FFF, 0xFFC0, 0x1FFF, 0xFFC0, 
  0x07FF, 0xFF80, 0x00FF, 0xFF00, 
  0x001F, 0xFE00, 0x0003, 0xFE00, 
  0x0000, 0x7C00, 0x0000, 0x0000
};

static  WORD RS41_MDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF000, 0x0006, 0x0F00, 
  0x0008, 0x00F0, 0x0013, 0xFC0F, 
  0x0021, 0xE003, 0x0043, 0x8006, 
  0x0087, 0x000E, 0x010E, 0x000A, 
  0x021C, 0x001A, 0x0438, 0x0032, 
  0x09FE, 0x0064, 0x101F, 0xFE44, 
  0x3F03, 0xF0C4, 0x7FE0, 0xC182, 
  0x60FC, 0x0303, 0x601F, 0x8203, 
  0xC003, 0xF606, 0xC000, 0x7C0C, 
  0xC000, 0x1808, 0xC000, 0x1018, 
  0x6000, 0x1030, 0x6000, 0x2060, 
  0x7800, 0x2040, 0x1F00, 0x20C0, 
  0x07E0, 0x2180, 0x00FC, 0x1300, 
  0x001F, 0x9200, 0x0003, 0xF600, 
  0x0000, 0x7C00, 0x0000, 0x0000
};

static  WORD RS41_4CMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF800, 0x0007, 0xFF80, 
  0x000F, 0xFFF8, 0x001F, 0xFFFF, 
  0x003F, 0xFFFF, 0x007F, 0xFFFE, 
  0x00FF, 0xFFFE, 0x01FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x07FF, 0xFFFE, 
  0x0FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x3FFF, 0xFFFC, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFF, 0x7FFF, 0xFFFF, 
  0xFFFF, 0xFFFE, 0xFFFF, 0xFFFC, 
  0xFFFF, 0xFFF8, 0xFFFF, 0xFFF8, 
  0x7FFF, 0xFFF0, 0x7FFF, 0xFFE0, 
  0x3FFF, 0xFFC0, 0x1FFF, 0xFFC0, 
  0x1FFF, 0xFF80, 0x3CFF, 0xFF00, 
  0x781F, 0xFE00, 0x3003, 0xFE00, 
  0x0000, 0x7C00, 0x0000, 0x0000
};

static  WORD RS41_4CDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF000, 0x0007, 0x5700, 
  0x000A, 0xAA70, 0x0017, 0xF957, 
  0x002B, 0xCAAB, 0x0057, 0xD556, 
  0x00AF, 0xAAAE, 0x015F, 0x554E, 
  0x02BE, 0xAABE, 0x057D, 0x5576, 
  0x0AFC, 0xAAE4, 0x154F, 0xFD64, 
  0x1EA9, 0xEAC4, 0x3FD5, 0x15B6, 
  0x72FA, 0xAB0A, 0x405F, 0x5316, 
  0x6D0B, 0xEE46, 0xC141, 0x7C04, 
  0xD20F, 0x5958, 0x6C83, 0x7A10, 
  0x5E50, 0x32B0, 0x7F05, 0x3420, 
  0x1CA0, 0xE0C0, 0x1E86, 0x2280, 
  0x1FD0, 0xB180, 0x3C7A, 0x3100, 
  0x780F, 0x7600, 0x3001, 0xFC00, 
  0x0000, 0x3800, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF000, 0x0007, 0x5700, 
  0x000A, 0xAA70, 0x0017, 0xF957, 
  0x002B, 0xCAAB, 0x0057, 0xD556, 
  0x00AF, 0xAAAE, 0x015F, 0x554E, 
  0x02BE, 0xAABE, 0x057D, 0x5576, 
  0x0AFC, 0xAAE4, 0x154F, 0xFD64, 
  0x1EA9, 0xEAC4, 0x3FD5, 0x15B6, 
  0x72FA, 0xAB0A, 0x405F, 0x5316, 
  0x6D0B, 0xEE46, 0xC141, 0x7C04, 
  0xD20F, 0x5958, 0x6083, 0x7A10, 
  0x4050, 0x32B0, 0x6305, 0x3420, 
  0x00A0, 0xE0C0, 0x0286, 0x2280, 
  0x03D0, 0xB180, 0x007A, 0x3100, 
  0x000F, 0x7600, 0x0001, 0xFC00, 
  0x0000, 0x3800, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF000, 0x0007, 0x5700, 
  0x000A, 0xAA70, 0x0017, 0xF957, 
  0x002B, 0xCAAB, 0x0057, 0xD556, 
  0x00AF, 0xAAAE, 0x015F, 0x554E, 
  0x02BE, 0xAABE, 0x057D, 0x5576, 
  0x0AFC, 0xAAE4, 0x154F, 0xFD64, 
  0x1EA9, 0xEAC4, 0x3FD5, 0x15B6, 
  0x72FA, 0xAB0A, 0x405F, 0x5316, 
  0x6D0B, 0xEE46, 0xC141, 0x7C04, 
  0xD20F, 0x5958, 0x6083, 0x7A10, 
  0x4050, 0x32B0, 0x6305, 0x3420, 
  0x00A0, 0xE0C0, 0x0286, 0x2280, 
  0x03D0, 0xB180, 0x007A, 0x3100, 
  0x000F, 0x7600, 0x0001, 0xFC00, 
  0x0000, 0x3800, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0001, 0xF800, 0x0006, 0x0F80, 
  0x000C, 0x00F8, 0x001B, 0xFC0F, 
  0x0031, 0xE007, 0x0063, 0x8006, 
  0x00C7, 0x000E, 0x018E, 0x001A, 
  0x031C, 0x001A, 0x0638, 0x0032, 
  0x0DFE, 0x0064, 0x181F, 0xFEC4, 
  0x3F03, 0xF0D4, 0x7FE0, 0xC182, 
  0x61FC, 0x0323, 0x603F, 0x864B, 
  0xC207, 0xF616, 0xC080, 0xFD0C, 
  0xCC00, 0x3A08, 0xC700, 0x9098, 
  0x6220, 0x1430, 0x6402, 0x2160, 
  0x2440, 0x2240, 0x0700, 0x20C0, 
  0x07E1, 0x2180, 0x04FC, 0x1300, 
  0x081F, 0x9200, 0x1003, 0xF600, 
  0x0000, 0x7C00, 0x0000, 0x0000
};

static  WORD RS41_4SMASK[] =
{ 0x0000, 0x0000, 0x0000, 0x01FF, 
  0x0001, 0xFFFF, 0x0007, 0xFFFE, 
  0x000F, 0xFFFC, 0x001F, 0xFFF8, 
  0x003F, 0xFFF0, 0x007F, 0xFFFE, 
  0x00FF, 0xFFFE, 0x01FF, 0xFFFE, 
  0x03FF, 0xFFFE, 0x07FF, 0xFFFE, 
  0x0FFF, 0xFFFC, 0x1FFF, 0xFFFC, 
  0x3FFF, 0xFFFC, 0x7FFF, 0xFFFE, 
  0x7FFF, 0xFFFF, 0x7FFF, 0xFFFF, 
  0xFFFF, 0xFFFE, 0xFFFF, 0xFFFC, 
  0xFFFF, 0xFFF8, 0xFFFF, 0xFFF8, 
  0x7FFF, 0xFFF0, 0x7FFF, 0xFFE0, 
  0x3FFF, 0xFFC0, 0x1FFF, 0xFFC0, 
  0x1FFF, 0xFF80, 0x3CFF, 0xFF00, 
  0x781F, 0xFE00, 0x3003, 0xFE00, 
  0x0000, 0x7C00, 0x0000, 0x0000
};

static  WORD RS41_4SDATA[] =
{ 0x0000, 0x0000, 0x0000, 0x01FF, 
  0x0001, 0xFEAB, 0x0007, 0x5556, 
  0x000A, 0xBEAC, 0x0017, 0xF548, 
  0x002B, 0xEA90, 0x0057, 0xD73E, 
  0x00AF, 0xAEE6, 0x015F, 0xFDC6, 
  0x02BF, 0xFB96, 0x05FF, 0x5716, 
  0x0AAA, 0x7E24, 0x147F, 0xF124, 
  0x1FF9, 0x0484, 0x3E80, 0x58B6, 
  0x72D2, 0x570A, 0x405A, 0x5116, 
  0x6D0B, 0x4446, 0xC141, 0x7C04, 
  0xD20F, 0x5958, 0x6C83, 0x7A10, 
  0x5E50, 0x32B0, 0x7F05, 0x3420, 
  0x1CA0, 0xE0C0, 0x1E86, 0x2280, 
  0x1FD0, 0xB180, 0x3C7A, 0x3100, 
  0x780F, 0x7600, 0x3001, 0xFC00, 
  0x0000, 0x3800, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x01FF, 
  0x0001, 0xFEAB, 0x0007, 0x5556, 
  0x000A, 0xBEAC, 0x0017, 0xF548, 
  0x002B, 0xEA90, 0x0057, 0xD73E, 
  0x00AF, 0xAEE6, 0x015F, 0xFDC6, 
  0x02BF, 0xFB96, 0x05FF, 0x5716, 
  0x0AAA, 0x7E24, 0x147F, 0xF124, 
  0x1FF9, 0x0484, 0x3E80, 0x58B6, 
  0x72D2, 0x570A, 0x405A, 0x5116, 
  0x6D0B, 0x4446, 0xC141, 0x7C04, 
  0xD20F, 0x5958, 0x6083, 0x7A10, 
  0x4050, 0x32B0, 0x6305, 0x3420, 
  0x00A0, 0xE0C0, 0x0286, 0x2280, 
  0x03D0, 0xB180, 0x007A, 0x3100, 
  0x000F, 0x7600, 0x0001, 0xFC00, 
  0x0000, 0x3800, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x01FF, 
  0x0001, 0xFEAB, 0x0007, 0x5556, 
  0x000A, 0xBEAC, 0x0017, 0xF548, 
  0x002B, 0xEA90, 0x0057, 0xD73E, 
  0x00AF, 0xAEE6, 0x015F, 0xFDC6, 
  0x02BF, 0xFB96, 0x05FF, 0x5716, 
  0x0AAA, 0x7E24, 0x147F, 0xF124, 
  0x1FF9, 0x0484, 0x3E80, 0x58B6, 
  0x72D2, 0x570A, 0x405A, 0x5116, 
  0x6D0B, 0x4446, 0xC141, 0x7C04, 
  0xD20F, 0x5958, 0x6083, 0x7A10, 
  0x4050, 0x32B0, 0x6305, 0x3420, 
  0x00A0, 0xE0C0, 0x0286, 0x2280, 
  0x03D0, 0xB180, 0x007A, 0x3100, 
  0x000F, 0x7600, 0x0001, 0xFC00, 
  0x0000, 0x3800, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x01FF, 
  0x0001, 0xFE03, 0x0006, 0x0006, 
  0x000C, 0x3E0C, 0x001B, 0xF018, 
  0x0031, 0xE030, 0x0063, 0x827E, 
  0x00C7, 0x0C66, 0x018F, 0xF8CA, 
  0x031F, 0xF1AA, 0x06FE, 0x0312, 
  0x0C01, 0xFEA4, 0x19FF, 0xFC44, 
  0x3FFE, 0x0354, 0x7F18, 0x2082, 
  0x61E1, 0x8923, 0x603C, 0x224B, 
  0xC207, 0x8216, 0xC080, 0xE50C, 
  0xCC00, 0x3A08, 0xC700, 0x9098, 
  0x6220, 0x1430, 0x6402, 0x2160, 
  0x2440, 0x2240, 0x0700, 0x20C0, 
  0x07E1, 0x2180, 0x04FC, 0x1300, 
  0x081F, 0x9200, 0x1003, 0xF600, 
  0x0000, 0x7C00, 0x0000, 0x0000
};

static  CICON rs_cicon[] =
{ 1, RS0_1CDATA, RS0_1CMASK, RS0_1SDATA, RS0_1SMASK, &rs_cicon[1],
  4, RS0_4CDATA, RS0_4CMASK, RS0_4SDATA, RS0_4SMASK, NULL,
  1, RS1_1CDATA, RS1_1CMASK, RS1_1SDATA, RS1_1SMASK, &rs_cicon[3],
  4, RS1_4CDATA, RS1_4CMASK, RS1_4SDATA, RS1_4SMASK, NULL,
  1, RS2_1CDATA, RS2_1CMASK, RS2_1SDATA, RS2_1SMASK, &rs_cicon[5],
  4, RS2_4CDATA, RS2_4CMASK, RS2_4SDATA, RS2_4SMASK, NULL,
  1, RS3_1CDATA, RS3_1CMASK, RS3_1SDATA, RS3_1SMASK, &rs_cicon[7],
  4, RS3_4CDATA, RS3_4CMASK, RS3_4SDATA, RS3_4SMASK, NULL,
  1, RS4_1CDATA, RS4_1CMASK, RS4_1SDATA, RS4_1SMASK, &rs_cicon[9],
  4, RS4_4CDATA, RS4_4CMASK, RS4_4SDATA, RS4_4SMASK, NULL,
  4, RS5_4CDATA, RS5_4CMASK, NULL, NULL, NULL,
  1, RS6_1CDATA, RS6_1CMASK, RS6_1SDATA, RS6_1SMASK, &rs_cicon[12],
  4, RS6_4CDATA, RS6_4CMASK, RS6_4SDATA, RS6_4SMASK, NULL,
  1, RS7_1CDATA, RS7_1CMASK, RS7_1SDATA, RS7_1SMASK, &rs_cicon[14],
  4, RS7_4CDATA, RS7_4CMASK, RS7_4SDATA, RS7_4SMASK, NULL,
  4, RS8_4CDATA, RS8_4CMASK, NULL, NULL, NULL,
  1, RS9_1CDATA, RS9_1CMASK, RS9_1SDATA, RS9_1SMASK, &rs_cicon[17],
  4, RS9_4CDATA, RS9_4CMASK, RS9_4SDATA, RS9_4SMASK, NULL,
  1, RS10_1CDATA, RS10_1CMASK, RS10_1SDATA, RS10_1SMASK, &rs_cicon[19],
  4, RS10_4CDATA, RS10_4CMASK, RS10_4SDATA, RS10_4SMASK, NULL,
  1, RS11_1CDATA, RS11_1CMASK, RS11_1SDATA, RS11_1SMASK, &rs_cicon[21],
  4, RS11_4CDATA, RS11_4CMASK, RS11_4SDATA, RS11_4SMASK, NULL,
  1, RS12_1CDATA, RS12_1CMASK, RS12_1SDATA, RS12_1SMASK, &rs_cicon[23],
  4, RS12_4CDATA, RS12_4CMASK, RS12_4SDATA, RS12_4SMASK, NULL,
  1, RS13_1CDATA, RS13_1CMASK, RS13_1SDATA, RS13_1SMASK, &rs_cicon[25],
  4, RS13_4CDATA, RS13_4CMASK, RS13_4SDATA, RS13_4SMASK, NULL,
  1, RS14_1CDATA, RS14_1CMASK, RS14_1SDATA, RS14_1SMASK, &rs_cicon[27],
  4, RS14_4CDATA, RS14_4CMASK, RS14_4SDATA, RS14_4SMASK, NULL,
  1, RS15_1CDATA, RS15_1CMASK, RS15_1SDATA, RS15_1SMASK, &rs_cicon[29],
  4, RS15_4CDATA, RS15_4CMASK, RS15_4SDATA, RS15_4SMASK, NULL,
  1, RS16_1CDATA, RS16_1CMASK, RS16_1SDATA, RS16_1SMASK, &rs_cicon[31],
  4, RS16_4CDATA, RS16_4CMASK, RS16_4SDATA, RS16_4SMASK, NULL,
  4, RS17_4CDATA, RS17_4CMASK, NULL, NULL, NULL,
  1, RS18_1CDATA, RS18_1CMASK, RS18_1SDATA, RS18_1SMASK, &rs_cicon[34],
  4, RS18_4CDATA, RS18_4CMASK, RS18_4SDATA, RS18_4SMASK, NULL,
  1, RS19_1CDATA, RS19_1CMASK, RS19_1SDATA, RS19_1SMASK, &rs_cicon[36],
  4, RS19_4CDATA, RS19_4CMASK, RS19_4SDATA, RS19_4SMASK, NULL,
  4, RS20_4CDATA, RS20_4CMASK, NULL, NULL, NULL,
  1, RS21_1CDATA, RS21_1CMASK, RS21_1SDATA, RS21_1SMASK, &rs_cicon[39],
  4, RS21_4CDATA, RS21_4CMASK, RS21_4SDATA, RS21_4SMASK, NULL,
  1, RS22_1CDATA, RS22_1CMASK, RS22_1SDATA, RS22_1SMASK, &rs_cicon[41],
  4, RS22_4CDATA, RS22_4CMASK, RS22_4SDATA, RS22_4SMASK, NULL,
  1, RS23_1CDATA, RS23_1CMASK, RS23_1SDATA, RS23_1SMASK, &rs_cicon[43],
  4, RS23_4CDATA, RS23_4CMASK, RS23_4SDATA, RS23_4SMASK, NULL,
  4, RS24_4CDATA, RS24_4CMASK, NULL, NULL, NULL,
  1, RS25_1CDATA, RS25_1CMASK, RS25_1SDATA, RS25_1SMASK, &rs_cicon[46],
  4, RS25_4CDATA, RS25_4CMASK, RS25_4SDATA, RS25_4SMASK, NULL,
  1, RS26_1CDATA, RS26_1CMASK, RS26_1SDATA, RS26_1SMASK, &rs_cicon[48],
  4, RS26_4CDATA, RS26_4CMASK, RS26_4SDATA, RS26_4SMASK, NULL,
  1, RS27_1CDATA, RS27_1CMASK, RS27_1SDATA, RS27_1SMASK, &rs_cicon[50],
  4, RS27_4CDATA, RS27_4CMASK, RS27_4SDATA, RS27_4SMASK, NULL,
  1, RS28_1CDATA, RS28_1CMASK, RS28_1SDATA, RS28_1SMASK, &rs_cicon[52],
  4, RS28_4CDATA, RS28_4CMASK, RS28_4SDATA, RS28_4SMASK, NULL,
  1, RS29_1CDATA, RS29_1CMASK, RS29_1SDATA, RS29_1SMASK, &rs_cicon[54],
  4, RS29_4CDATA, RS29_4CMASK, RS29_4SDATA, RS29_4SMASK, NULL,
  1, RS30_1CDATA, RS30_1CMASK, RS30_1SDATA, RS30_1SMASK, &rs_cicon[56],
  4, RS30_4CDATA, RS30_4CMASK, RS30_4SDATA, RS30_4SMASK, NULL,
  1, RS31_1CDATA, RS31_1CMASK, RS31_1SDATA, RS31_1SMASK, &rs_cicon[58],
  4, RS31_4CDATA, RS31_4CMASK, RS31_4SDATA, RS31_4SMASK, NULL,
  1, RS32_1CDATA, RS32_1CMASK, RS32_1SDATA, RS32_1SMASK, &rs_cicon[60],
  4, RS32_4CDATA, RS32_4CMASK, RS32_4SDATA, RS32_4SMASK, NULL,
  4, RS33_4CDATA, RS33_4CMASK, NULL, NULL, NULL,
  4, RS34_4CDATA, RS34_4CMASK, NULL, NULL, NULL,
  4, RS35_4CDATA, RS35_4CMASK, RS35_4SDATA, RS35_4SMASK, &rs_cicon[64],
  1, RS35_1CDATA, RS35_1CMASK, RS35_1SDATA, RS35_1SMASK, NULL,
  4, RS36_4CDATA, RS36_4CMASK, RS36_4SDATA, RS36_4SMASK, NULL,
  4, RS37_4CDATA, RS37_4CMASK, RS37_4SDATA, RS37_4SMASK, NULL,
  4, RS38_4CDATA, RS38_4CMASK, RS38_4SDATA, RS38_4SMASK, NULL,
  4, RS39_4CDATA, RS39_4CMASK, RS39_4SDATA, RS39_4SMASK, NULL,
  4, RS40_4CDATA, RS40_4CMASK, RS40_4SDATA, RS40_4SMASK, NULL,
  4, RS41_4CDATA, RS41_4CMASK, RS41_4SDATA, RS41_4SMASK, NULL
};

static  CICONBLK rs_ciconblk[] =
{ RS0_MMASK, RS0_MDATA, "\0\000", 0x1000|'\0',
    0,   0,   0,   0,  16,  16,   0,  -1,   6,   8, &rs_cicon[0],
  RS1_MMASK, RS1_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[2],
  RS2_MMASK, RS2_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[4],
  RS3_MMASK, RS3_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[6],
  RS4_MMASK, RS4_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[8],
  RS5_MMASK, RS5_MDATA, "\0", 0x1000|'\0',
    5,   4,   0,   0,  16,  16,   0,   0,   0,   8, &rs_cicon[10],
  RS6_MMASK, RS6_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[11],
  RS7_MMASK, RS7_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   9,  16,   6,   8, &rs_cicon[13],
  RS8_MMASK, RS8_MDATA, "\0", 0x1000|'\0',
    5,   6,   0,   0,  16,  16,   0,   0,   0,   8, &rs_cicon[15],
  RS9_MMASK, RS9_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[16],
  RS10_MMASK, RS10_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[18],
  RS11_MMASK, RS11_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   5,   5,   6,   8, &rs_cicon[20],
  RS12_MMASK, RS12_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   5,   1,   6,   8, &rs_cicon[22],
  RS13_MMASK, RS13_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[24],
  RS14_MMASK, RS14_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[26],
  RS15_MMASK, RS15_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[28],
  RS16_MMASK, RS16_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[30],
  RS17_MMASK, RS17_MDATA, "\0", 0x1000|'\0',
    5,   2,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[32],
  RS18_MMASK, RS18_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[33],
  RS19_MMASK, RS19_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[35],
  RS20_MMASK, RS20_MDATA, "\0", 0x1000|'\0',
    5,   2,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[37],
  RS21_MMASK, RS21_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[38],
  RS22_MMASK, RS22_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[40],
  RS23_MMASK, RS23_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[42],
  RS24_MMASK, RS24_MDATA, "\0", 0x1000|'\0',
    5,   4,   0,   0,  16,  16,   0,   0,   0,   8, &rs_cicon[44],
  RS25_MMASK, RS25_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   0,  16,   6,   8, &rs_cicon[45],
  RS26_MMASK, RS26_MDATA, "\0\000", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   0,  10,   6,   8, &rs_cicon[47],
  RS27_MMASK, RS27_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   0,   0,   0,   8, &rs_cicon[49],
  RS28_MMASK, RS28_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[51],
  RS29_MMASK, RS29_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   0,   0,   0,   8, &rs_cicon[53],
  RS30_MMASK, RS30_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[55],
  RS31_MMASK, RS31_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,  16,   0,   0,   0,   8, &rs_cicon[57],
  RS32_MMASK, RS32_MDATA, "\0", 0x1000|'\0',
   14,  21,   0,   0,  16,   8,   0,   0,   0,   8, &rs_cicon[59],
  RS33_MMASK, RS33_MDATA, "\0\000", 0x1000|'\0',
    0,   0,   0,   0,  32,  32,  13,  13,   6,   8, &rs_cicon[61],
  RS34_MMASK, RS34_MDATA, "\0", 0x1000|'\0',
    0,   0,   0,   0,  32,  32,   0,   0,   0,   8, &rs_cicon[62],
  RS35_MMASK, RS35_MDATA, "\0\000", 0x1000|'\0',
    0,   0,   0,   0,  32,  32,  13,  13,   6,   8, &rs_cicon[63],
  RS36_MMASK, RS36_MDATA, "\0", 0x1000|'\0',
    0,   0,   0,   0,  32,  32,   0,   0,   0,   8, &rs_cicon[65],
  RS37_MMASK, RS37_MDATA, "\0", 0x1000|'\0',
   22,  24,   0,   0,  32,  32,   0,   0,   0,   8, &rs_cicon[66],
  RS38_MMASK, RS38_MDATA, "\0\000", 0x1000|'\0',
    0,   0,   0,   0,  32,  32,  13,  13,   6,   8, &rs_cicon[67],
  RS39_MMASK, RS39_MDATA, "\0", 0x1000|'\0',
    0,   0,   0,   0,  48,  32,   0,   0,   0,   8, &rs_cicon[68],
  RS40_MMASK, RS40_MDATA, "\0", 0x1000|'\0',
    3,   2,   0,   0,  32,  32,   0,   0,   0,   8, &rs_cicon[69],
  RS41_MMASK, RS41_MDATA, "\0\000", 0x1000|'\0',
    0,   0,   0,   0,  32,  32,  13,  13,   6,   8, &rs_cicon[70]
};
/*
static  WORD rgb_palette[][4] =
{ 0x03E8, 0x03E8, 0x03E8, 0x0000, 
  0x03E8, 0x0000, 0x0000, 0x0002, 
  0x0000, 0x03E8, 0x0000, 0x0003, 
  0x03E8, 0x03E8, 0x0000, 0x0006, 
  0x0000, 0x0000, 0x03E8, 0x0004, 
  0x03E8, 0x0000, 0x03E8, 0x0007, 
  0x0000, 0x03E8, 0x03E8, 0x0005, 
  0x0329, 0x0329, 0x0329, 0x0008, 
  0x01EC, 0x01EC, 0x01EC, 0x0009, 
  0x01EC, 0x0000, 0x0000, 0x000A, 
  0x0000, 0x01EC, 0x0000, 0x000B, 
  0x01EC, 0x01EC, 0x0000, 0x000E, 
  0x0000, 0x0000, 0x01EC, 0x000C, 
  0x01EC, 0x0000, 0x01EC, 0x000F, 
  0x0000, 0x01EC, 0x01EC, 0x000D, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0000, 
  0x0000, 0x0000, 0x0000, 0x0001
};
*/
static  BYTE *rs_frstr[] =
{ "[3][|Let\047em Fly est install\202 avec|l\047option NiceLine:|Annulez cette option avec|LET_CONF.CPX][  OK  ]",
  "[3][|Let\047em Fly is installed with|the NiceLine option:|Remove it with LET_CONF.CPX][  OK  ]",
  "[3][|Le nombre maximal de|fen\210tres a \202t\202 atteint:|Ouverture impossible !][  OK  ]",
  "[3][|The max number of opened|windows is over:|Cannot open a new one !][  OK  ]",
  "[3][|Impossible de trouver les|fichiers d\047aide dans le|chemin pr\202d\202fini !][  OK  ]",
  "[3][|Cannot reach the help files|in the predefined path !][  OK  ]",
  "EGlib est distribu\202e|EGlib is distributed under",
  "selon les termes de la|terms of the",
  "[Changer|[Set",
  "Couleur texte:|Text color:",
  "Couleur fond:|Background color:",
  "Fonte GDOS pour le GEM|Default GDOS font in GEM",
  "Fonte GDOS pour l\047aide en ligne|Default GDOS font in online help",
  "Taille texte:|text size:",
  "Fontes [GDOS dans GEM|Use [GDOS font in GEM",
  "Fontes GDOS dans l\047[Aide|Use GDOS font in [Help",
  "[PopUp clignotant|Flashing [PopUp",
  "Plein \202cran avec [Marges|Full size vith [Margin",
  "Sauver [config de la lib|Save lib [config",
  "Formulaires \205 la souris|Form windows to mouse",
  "Jamais|Never",
  "1\212re ouverture fen\210tre|1st window opening",
  "Toujours|Always",
  "Chemin des fichiers d\047aide|Help files directory",
  "[Sauver dans fichier|[Save in a file",
  "  Infos EGlib|  EGlib infos",
  "  Gestion M\202moire|  Memory Manager",
  "  Choix Fontes|  Font Manager",
  "  Options|  Options",
  "  Infos syst\212me|  System Info",
  "  Sauver Config|  Save Config",
  "  Aide en ligne|  Online Help",
  "  Sommaire|  Help index",
  "  Page pr\202c\202dente|  Previous topic",
  "  Page suivante|  Next topic",
  " Blanc| White",
  " Noir| Black",
  " Rouge| Red",
  " Vert| Green",
  " Bleu| Blue",
  " Cyan| Cyan",
  " Jaune| Yellow",
  " Rose| Magenta",
  " Gris| Grey",
  " Gris fonc\202| Dark Grey",
  " Rouge fonc\202| Dark Red",
  " Vert fonc\202| Dark Green",
  " Bleu fonc\202| Dark Blue",
  " Cyan fonc\202| Dark Cyan",
  " Jaune fonc\202| Dark Yellow",
  " Rose fonc\202| Dark Magenta",
  "A PROPOS DE EGlib|ABOUT EGlib",
  "GESTION MEMOIRE|MEMORY MANAGER",
  "CHOIX FONTE|FONT MANAGER",
  "OPTIONS DE EGlib|EGlib OPTIONS",
  "INFORMATIONS SYSTEME|SYSTEM INFOS",
  "AIDE EN LIGNE|ONLINE HELP"
};

static  OBJECT rs_object[] =
{ 
  /******** Tree 0 HWIN ****************************************************/
        -1, FWINCLS         , FWINSIZ         , G_BOX             ,   /* Object 0  */
  NONE, NORMAL, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x003A, 0x0012,
  FWINAME         ,       -1,       -1, G_CICON           ,   /* Object 1 FWINCLS */
  NONE, NORMAL, (LONG)&rs_ciconblk[0],
  0x0000, 0x0000, 0x0002, 0x0101,
  FWINCYC         ,       -1,       -1, G_BOXTEXT         ,   /* Object 2 FWINAME */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[0],
  0x0002, 0x0000, 0x0030, 0x0001,
  FWINICO         ,       -1,       -1, G_CICON           ,   /* Object 3 FWINCYC */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[1],
  0x0032, 0x0000, 0x0002, 0x0001,
  FWINPOP         ,       -1,       -1, G_CICON           ,   /* Object 4 FWINICO */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[2],
  0x0034, 0x0000, 0x0002, 0x0001,
  FWINFUL         ,       -1,       -1, G_CICON           ,   /* Object 5 FWINPOP */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[3],
  0x0036, 0x0000, 0x0002, 0x0001,
  FWINVSF         ,       -1,       -1, G_CICON           ,   /* Object 6 FWINFUL */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[4],
  0x0038, 0x0000, 0x0002, 0x0001,
  FWINUAR         , FWINVSP         , FWINVSP         , G_BOXTEXT         ,   /* Object 7 FWINVSF */
  NONE, NORMAL, (LONG)&rs_tedinfo[1],
  0x0038, 0x0001, 0x0002, 0x0006,
  FWINVSF         , FWINVSI         , FWINVSI         , G_BOXTEXT         ,   /* Object 8 FWINVSP */
  NONE, WHITEBAK, (LONG)&rs_tedinfo[2],
  0x0000, 0x0001, 0x0002, 0x0003,
  FWINVSP         ,       -1,       -1, G_CICON           ,   /* Object 9 FWINVSI */
  NONE, NORMAL, (LONG)&rs_ciconblk[5],
  0x0000, 0x0001, 0x0002, 0x0001,
  FWINDAR         ,       -1,       -1, G_CICON           ,   /* Object 10 FWINUAR */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[6],
  0x0038, 0x000F, 0x0002, 0x0001,
  FWINHSF         ,       -1,       -1, G_CICON           ,   /* Object 11 FWINDAR */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[7],
  0x0038, 0x0010, 0x0002, 0x0801,
  FWINLAR         , FWINHSP         , FWINHSP         , G_BOXTEXT         ,   /* Object 12 FWINHSF */
  NONE, NORMAL, (LONG)&rs_tedinfo[3],
  0x0000, 0x0011, 0x0015, 0x0001,
  FWINHSF         , FWINHSI         , FWINHSI         , G_BOXTEXT         ,   /* Object 13 FWINHSP */
  NONE, WHITEBAK, (LONG)&rs_tedinfo[4],
  0x0001, 0x0000, 0x0006, 0x0001,
  FWINHSP         ,       -1,       -1, G_CICON           ,   /* Object 14 FWINHSI */
  NONE, NORMAL, (LONG)&rs_ciconblk[8],
  0x0002, 0x0000, 0x0002, 0x0001,
  FWINRAR         ,       -1,       -1, G_CICON           ,   /* Object 15 FWINLAR */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[9],
  0x0034, 0x0011, 0x0002, 0x0001,
  FWINSIZ         ,       -1,       -1, G_CICON           ,   /* Object 16 FWINRAR */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[10],
  0x0036, 0x0011, 0x0002, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 17 FWINSIZ */
  SELECTABLE|LASTOB, NORMAL, (LONG)&rs_ciconblk[11],
  0x0038, 0x0011, 0x0002, 0x0001,
  
  /******** Tree 1 LWIN ****************************************************/
        -1,        1,       17, G_BOX             ,   /* Object 0  */
  NONE, NORMAL, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x003A, 0x0013,
         2,       -1,       -1, G_CICON           ,   /* Object 1  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[12],
  0x0000, 0x0000, 0x0002, 0x0900,
         3,       -1,       -1, G_BOXTEXT         ,   /* Object 2  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[5],
  0x0002, 0x0000, 0x0030, 0x0001,
         4,       -1,       -1, G_CICON           ,   /* Object 3  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[13],
  0x0032, 0x0000, 0x0002, 0x0800,
         5,       -1,       -1, G_CICON           ,   /* Object 4  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[14],
  0x0034, 0x0000, 0x0002, 0x0800,
         6,       -1,       -1, G_CICON           ,   /* Object 5  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[15],
  0x0036, 0x0000, 0x0002, 0x0800,
         7,       -1,       -1, G_CICON           ,   /* Object 6  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[16],
  0x0038, 0x0000, 0x0002, 0x0800,
        10,        8,        8, G_BOXTEXT         ,   /* Object 7  */
  NONE, NORMAL, (LONG)&rs_tedinfo[6],
  0x0038, 0x0001, 0x0002, 0x000F,
         7,        9,        9, G_BOXTEXT         ,   /* Object 8  */
  NONE, WHITEBAK, (LONG)&rs_tedinfo[7],
  0x0000, 0x0001, 0x0002, 0x000C,
         8,       -1,       -1, G_CICON           ,   /* Object 9  */
  NONE, NORMAL, (LONG)&rs_ciconblk[17],
  0x0000, 0x0006, 0x0002, 0x0800,
        11,       -1,       -1, G_CICON           ,   /* Object 10  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[18],
  0x0038, 0x0010, 0x0002, 0x0800,
        12,       -1,       -1, G_CICON           ,   /* Object 11  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[19],
  0x0038, 0x0011, 0x0002, 0x0800,
        15,       13,       13, G_BOXTEXT         ,   /* Object 12  */
  NONE, NORMAL, (LONG)&rs_tedinfo[8],
  0x0000, 0x0012, 0x0034, 0x0001,
        12,       14,       14, G_BOXTEXT         ,   /* Object 13  */
  NONE, WHITEBAK, (LONG)&rs_tedinfo[9],
  0x0002, 0x0000, 0x001B, 0x0001,
        13,       -1,       -1, G_CICON           ,   /* Object 14  */
  NONE, NORMAL, (LONG)&rs_ciconblk[20],
  0x000D, 0x0000, 0x0002, 0x0800,
        16,       -1,       -1, G_CICON           ,   /* Object 15  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[21],
  0x0034, 0x0012, 0x0002, 0x0800,
        17,       -1,       -1, G_CICON           ,   /* Object 16  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[22],
  0x0036, 0x0012, 0x0002, 0x0800,
         0,       -1,       -1, G_CICON           ,   /* Object 17  */
  SELECTABLE|LASTOB, NORMAL, (LONG)&rs_ciconblk[23],
  0x0038, 0x0012, 0x0002, 0x0800,
  
  /******** Tree 2 FPOP ****************************************************/
        -1, FPOPBOX         , FPOPBOX         , G_BOX             ,   /* Object 0  */
  NONE, NORMAL, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0017, 0x0008,
         0, FPOPF           , FPOPDN          , G_BOX             ,   /* Object 1 FPOPBOX */
  NONE, NORMAL, (LONG)0x00FF1100L,
  0x0015, 0x0000, 0x0002, 0x0008,
  FPOPUP          , FPOPP           , FPOPP           , G_BOXTEXT         ,   /* Object 2 FPOPF */
  NONE, NORMAL, (LONG)&rs_tedinfo[10],
  0x0000, 0x0000, 0x0002, 0x0005,
  FPOPF           , FPOPI           , FPOPI           , G_BOXTEXT         ,   /* Object 3 FPOPP */
  NONE, WHITEBAK, (LONG)&rs_tedinfo[11],
  0x0000, 0x0001, 0x0002, 0x0003,
  FPOPP           ,       -1,       -1, G_CICON           ,   /* Object 4 FPOPI */
  NONE, STATE15, (LONG)&rs_ciconblk[24],
  0x0000, 0x0001, 0x0002, 0x0001,
  FPOPDN          ,       -1,       -1, G_CICON           ,   /* Object 5 FPOPUP */
  SELECTABLE, STATE15, (LONG)&rs_ciconblk[25],
  0x0000, 0x0005, 0x0002, 0x0801,
  FPOPBOX         ,       -1,       -1, G_CICON           ,   /* Object 6 FPOPDN */
  SELECTABLE|LASTOB, STATE15, (LONG)&rs_ciconblk[26],
  0x0000, 0x0006, 0x0002, 0x0201,
  
  /******** Tree 3 FUSER ****************************************************/
        -1, FUSDPOP         ,       18, G_BOX             ,   /* Object 0  */
  FLAGS10, WHITEBAK, (LONG)0x00011180L,
  0x0000, 0x0000, 0x001E, 0x000A,
         2,       -1,       -1, G_CICON           ,   /* Object 1 FUSDPOP */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[27],
  0x0001, 0x0001, 0x0002, 0x0001,
  FUSDCIR         ,       -1,       -1, G_CICON           ,   /* Object 2  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[28],
  0x0004, 0x0001, 0x0002, 0x0800,
         4,       -1,       -1, G_CICON           ,   /* Object 3 FUSDCIR */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[29],
  0x0008, 0x0001, 0x0002, 0x0001,
  FUSDCAR         ,       -1,       -1, G_CICON           ,   /* Object 4  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[30],
  0x000B, 0x0001, 0x0002, 0x0800,
         6,       -1,       -1, G_CICON           ,   /* Object 5 FUSDCAR */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[31],
  0x000F, 0x0001, 0x0002, 0x0001,
  FUSDDAR         ,       -1,       -1, G_CICON           ,   /* Object 6  */
  SELECTABLE, NORMAL, (LONG)&rs_ciconblk[32],
  0x0012, 0x0001, 0x0002, 0x0800,
         8,       -1,       -1, G_IMAGE           ,   /* Object 7 FUSDDAR */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[0],
  0x0001, 0x0003, 0x0002, 0x0001,
  FUSDUAR         ,       -1,       -1, G_IMAGE           ,   /* Object 8  */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[1],
  0x0004, 0x0003, 0x0002, 0x0800,
        10,       -1,       -1, G_IMAGE           ,   /* Object 9 FUSDUAR */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[2],
  0x0008, 0x0003, 0x0002, 0x0001,
  FUSDLAR         ,       -1,       -1, G_IMAGE           ,   /* Object 10  */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[3],
  0x000B, 0x0003, 0x0002, 0x0800,
        12,       -1,       -1, G_IMAGE           ,   /* Object 11 FUSDLAR */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[4],
  0x000F, 0x0003, 0x0002, 0x0001,
  FUSDRAR         ,       -1,       -1, G_IMAGE           ,   /* Object 12  */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[5],
  0x0012, 0x0003, 0x0002, 0x0800,
        14,       -1,       -1, G_IMAGE           ,   /* Object 13 FUSDRAR */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[6],
  0x0016, 0x0003, 0x0002, 0x0001,
  FUSDLQAR        ,       -1,       -1, G_IMAGE           ,   /* Object 14  */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[7],
  0x0019, 0x0003, 0x0002, 0x0800,
        16,       -1,       -1, G_IMAGE           ,   /* Object 15 FUSDLQAR */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[8],
  0x0001, 0x0004, 0x0002, 0x0001,
  FUSDRQAR        ,       -1,       -1, G_IMAGE           ,   /* Object 16  */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[9],
  0x0004, 0x0004, 0x0002, 0x0800,
        18,       -1,       -1, G_IMAGE           ,   /* Object 17 FUSDRQAR */
  TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[10],
  0x0008, 0x0004, 0x0002, 0x0001,
         0,       -1,       -1, G_IMAGE           ,   /* Object 18  */
  LASTOB|TOUCHEXIT, NORMAL, (LONG)&rs_bitblk[11],
  0x000B, 0x0004, 0x0002, 0x0800,
  
  /******** Tree 4 FMOUSE ****************************************************/
        -1,        1, FSOUFNT         , G_BOX             ,   /* Object 0  */
  NONE, NORMAL, (LONG)0x00FF1100L,
  0x0000, 0x0000, 0x0019, 0x0009,
         2,       -1,       -1, G_ICON            ,   /* Object 1  */
  NONE, NORMAL, (LONG)&rs_iconblk[0],
  0x0001, 0x0001, 0x0002, 0x0001,
         3,       -1,       -1, G_ICON            ,   /* Object 2  */
  NONE, NORMAL, (LONG)&rs_iconblk[1],
  0x0004, 0x0001, 0x0002, 0x0001,
         4,       -1,       -1, G_ICON            ,   /* Object 3  */
  NONE, NORMAL, (LONG)&rs_iconblk[2],
  0x0007, 0x0001, 0x0002, 0x0001,
         5,       -1,       -1, G_ICON            ,   /* Object 4  */
  NONE, NORMAL, (LONG)&rs_iconblk[3],
  0x000A, 0x0001, 0x0002, 0x0001,
         6,       -1,       -1, G_ICON            ,   /* Object 5  */
  NONE, NORMAL, (LONG)&rs_iconblk[4],
  0x000D, 0x0001, 0x0002, 0x0001,
         7,       -1,       -1, G_ICON            ,   /* Object 6  */
  NONE, NORMAL, (LONG)&rs_iconblk[5],
  0x0010, 0x0001, 0x0002, 0x0001,
         8,       -1,       -1, G_ICON            ,   /* Object 7  */
  NONE, NORMAL, (LONG)&rs_iconblk[6],
  0x0013, 0x0001, 0x0002, 0x0001,
  FSOUSIZ         ,       -1,       -1, G_ICON            ,   /* Object 8  */
  NONE, NORMAL, (LONG)&rs_iconblk[7],
  0x0016, 0x0001, 0x0002, 0x0001,
  FSOUUPDN        ,       -1,       -1, G_ICON            ,   /* Object 9 FSOUSIZ */
  NONE, NORMAL, (LONG)&rs_iconblk[8],
  0x0001, 0x0003, 0x0002, 0x0001,
  FSOUUP          ,       -1,       -1, G_ICON            ,   /* Object 10 FSOUUPDN */
  NONE, NORMAL, (LONG)&rs_iconblk[9],
  0x0004, 0x0003, 0x0002, 0x0001,
  FSOUDN          ,       -1,       -1, G_ICON            ,   /* Object 11 FSOUUP */
  NONE, NORMAL, (LONG)&rs_iconblk[10],
  0x0007, 0x0003, 0x0002, 0x0001,
  FSOUFNT         ,       -1,       -1, G_ICON            ,   /* Object 12 FSOUDN */
  NONE, NORMAL, (LONG)&rs_iconblk[11],
  0x000A, 0x0003, 0x0002, 0x0001,
         0,       -1,       -1, G_ICON            ,   /* Object 13 FSOUFNT */
  LASTOB, NORMAL, (LONG)&rs_iconblk[12],
  0x0001, 0x0005, 0x0002, 0x0801,
  
  /******** Tree 5 FINF ****************************************************/
        -1,        1,       13, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1100L,
  0x0000, 0x0000, 0x0025, 0x0013,
        13,        2, FINFC3          , G_IBOX            ,   /* Object 1  */
  NONE, DRAW3D|WHITEBAK, (LONG)0x00FF1100L,
  0x0002, 0x0001, 0x0021, 0x000D,
  FINFVER         ,       -1,       -1, G_TEXT            |0x1800,   /* Object 2  */
  NONE, STATE10|STATE13, (LONG)&rs_tedinfo[12],
  0x0002, 0x0000, 0x001D, 0x0003,
         4,       -1,       -1, G_TEXT            ,   /* Object 3 FINFVER */
  NONE, NORMAL, (LONG)&rs_tedinfo[13],
  0x0001, 0x0003, 0x001F, 0x0001,
         5,       -1,       -1, G_TEXT            ,   /* Object 4  */
  NONE, STATE10, (LONG)&rs_tedinfo[14],
  0x0001, 0x0004, 0x001F, 0x0001,
         6,       -1,       -1, G_TEXT            ,   /* Object 5  */
  NONE, STATE10, (LONG)&rs_tedinfo[15],
  0x0001, 0x0005, 0x001F, 0x0001,
         7,       -1,       -1, G_TEXT            ,   /* Object 6  */
  NONE, STATE10, (LONG)&rs_tedinfo[16],
  0x0001, 0x0006, 0x001F, 0x0001,
         8,       -1,       -1, G_TEXT            ,   /* Object 7  */
  NONE, STATE10, (LONG)&rs_tedinfo[17],
  0x0001, 0x0007, 0x001F, 0x0001,
  FINFC1          ,       -1,       -1, G_TEXT            ,   /* Object 8  */
  NONE, NORMAL, (LONG)&rs_tedinfo[18],
  0x0001, 0x0008, 0x001F, 0x0001,
  FINFC2          ,       -1,       -1, G_TEXT            ,   /* Object 9 FINFC1 */
  NONE, STATE10, (LONG)&rs_tedinfo[19],
  0x0001, 0x0009, 0x001F, 0x0001,
        11,       -1,       -1, G_TEXT            ,   /* Object 10 FINFC2 */
  NONE, STATE10, (LONG)&rs_tedinfo[20],
  0x0001, 0x000A, 0x001F, 0x0001,
  FINFC3          ,       -1,       -1, G_TEXT            ,   /* Object 11  */
  NONE, STATE10|STATE13, (LONG)&rs_tedinfo[21],
  0x0001, 0x000B, 0x001F, 0x0001,
         1,       -1,       -1, G_TEXT            ,   /* Object 12 FINFC3 */
  NONE, STATE10, (LONG)&rs_tedinfo[22],
  0x0001, 0x000C, 0x001F, 0x0001,
         0,       14, FINFPT2         , G_IBOX            ,   /* Object 13  */
  NONE, DRAW3D|WHITEBAK, (LONG)0x00FF1100L,
  0x0002, 0x000F, 0x0021, 0x0003,
  FINFPT1         ,       -1,       -1, G_TEXT            ,   /* Object 14  */
  NONE, STATE13, (LONG)&rs_tedinfo[23],
  0x0001, 0x0000, 0x001F, 0x0001,
  FINFPT2         ,       -1,       -1, G_TEXT            ,   /* Object 15 FINFPT1 */
  NONE, STATE10, (LONG)&rs_tedinfo[24],
  0x0001, 0x0001, 0x001F, 0x0001,
        13,       -1,       -1, G_TEXT            ,   /* Object 16 FINFPT2 */
  LASTOB, STATE10, (LONG)&rs_tedinfo[25],
  0x0001, 0x0002, 0x001F, 0x0001,
  
  /******** Tree 6 FMEM ****************************************************/
        -1,        1, FMEMMOD         , G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x001A, 0x000B,
  FMEMMIN         , FMEMLEN         , FMEMSYS         , G_IBOX            ,   /* Object 1  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0002, 0x0001, 0x0016, 0x0005,
  FMEMFRE         ,       -1,       -1, G_FTEXT           ,   /* Object 2 FMEMLEN */
  EDITABLE, WHITEBAK|STATE9, (LONG)&rs_tedinfo[26],
  0x0002, 0x0001, 0x0012, 0x0001,
  FMEMSYS         ,       -1,       -1, G_TEXT            ,   /* Object 3 FMEMFRE */
  NONE, WHITEBAK|STATE9, (LONG)&rs_tedinfo[27],
  0x0002, 0x0002, 0x0012, 0x0001,
         1,       -1,       -1, G_TEXT            ,   /* Object 4 FMEMSYS */
  NONE, WHITEBAK|STATE9, (LONG)&rs_tedinfo[28],
  0x0002, 0x0003, 0x0012, 0x0001,
  FMEMMAX         ,       -1,       -1, G_BUTTON          ,   /* Object 5 FMEMMIN */
  SELECTABLE, DRAW3D, (LONG)"M[inimum",
  0x0002, 0x0007, 0x000A, 0x0001,
  FMEMMOD         ,       -1,       -1, G_BUTTON          ,   /* Object 6 FMEMMAX */
  SELECTABLE, DRAW3D, (LONG)"M[aximum",
  0x000E, 0x0007, 0x000A, 0x0001,
         0,       -1,       -1, G_BUTTON          ,   /* Object 7 FMEMMOD */
  SELECTABLE|LASTOB, DRAW3D, (LONG)"\0",
  0x0002, 0x0009, 0x0016, 0x0001,
  
  /******** Tree 7 FFNT ****************************************************/
        -1,        1,        6, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1100L,
  0x0000, 0x0000, 0x0027, 0x0013,
         6, FFNTGTIT        , FFNTGNOM        , G_IBOX            ,   /* Object 1  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0001, 0x0001, 0x0025, 0x0006,
  FFNTGPOP        ,       -1,       -1, G_TEXT            ,   /* Object 2 FFNTGTIT */
  NONE, SELECTED, (LONG)&rs_tedinfo[29],
  0x0000, 0x0000, 0x0025, 0x0001,
  FFNTGTYP        ,       -1,       -1, G_BUTTON          |0x0400,   /* Object 3 FFNTGPOP */
  SELECTABLE, DRAW3D, (LONG)"FFNTGPOP--------------------------",
  0x0001, 0x0002, 0x0023, 0x0001,
  FFNTGNOM        ,       -1,       -1, G_TEXT            ,   /* Object 4 FFNTGTYP */
  NONE, STATE9, (LONG)&rs_tedinfo[30],
  0x0001, 0x0003, 0x0023, 0x0001,
         1,       -1,       -1, G_BOXTEXT         ,   /* Object 5 FFNTGNOM */
  SELECTABLE, DRAW3D|STATE8, (LONG)&rs_tedinfo[31],
  0x0001, 0x0004, 0x0023, 0x0001,
         0, FFNTHTIT        , FFNTHSET        , G_IBOX            ,   /* Object 6  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0001, 0x0008, 0x0025, 0x000A,
  FFNTHPOP        ,       -1,       -1, G_TEXT            ,   /* Object 7 FFNTHTIT */
  NONE, SELECTED, (LONG)&rs_tedinfo[32],
  0x0000, 0x0000, 0x0025, 0x0001,
  FFNTHTYP        ,       -1,       -1, G_BUTTON          |0x0400,   /* Object 8 FFNTHPOP */
  SELECTABLE, DRAW3D, (LONG)"FFNTHPOP--------------------------",
  0x0001, 0x0002, 0x0023, 0x0001,
  FFNTHNOM        ,       -1,       -1, G_TEXT            ,   /* Object 9 FFNTHTYP */
  NONE, STATE9, (LONG)&rs_tedinfo[33],
  0x0001, 0x0003, 0x0023, 0x0001,
  FFNTTTXT        ,       -1,       -1, G_BOXTEXT         ,   /* Object 10 FFNTHNOM */
  SELECTABLE, DRAW3D|STATE11, (LONG)&rs_tedinfo[34],
  0x0001, 0x0004, 0x0023, 0x0001,
  FFNTTFON        ,       -1,       -1, G_TEXT            ,   /* Object 11 FFNTTTXT */
  NONE, WHITEBAK|STATE9, (LONG)&rs_tedinfo[35],
  0x0001, 0x0005, 0x0010, 0x0001,
  FFNTCTXT        ,       -1,       -1, G_TEXT            ,   /* Object 12 FFNTTFON */
  NONE, WHITEBAK|STATE9, (LONG)&rs_tedinfo[36],
  0x0014, 0x0005, 0x0010, 0x0001,
  FFNTCFON        ,       -1,       -1, G_BUTTON          |0x0300,   /* Object 13 FFNTCTXT */
  SELECTABLE, DRAW3D, (LONG)"FFNTCRXT--------",
  0x0001, 0x0006, 0x0010, 0x0001,
  FFNTHTXT        ,       -1,       -1, G_BUTTON          |0x0300,   /* Object 14 FFNTCFON */
  SELECTABLE, DRAW3D, (LONG)"FFNTCFON--------",
  0x0014, 0x0006, 0x0010, 0x0001,
  FFNTHSIZ        ,       -1,       -1, G_TEXT            ,   /* Object 15 FFNTHTXT */
  NONE, WHITEBAK, (LONG)&rs_tedinfo[37],
  0x0001, 0x0008, 0x000D, 0x0001,
  FFNTHSET        ,       -1,       -1, G_FTEXT           ,   /* Object 16 FFNTHSIZ */
  EDITABLE, WHITEBAK, (LONG)&rs_tedinfo[38],
  0x000F, 0x0008, 0x0003, 0x0001,
         6,       -1,       -1, G_BUTTON          ,   /* Object 17 FFNTHSET */
  SELECTABLE|LASTOB, DRAW3D, (LONG)"\0",
  0x0014, 0x0008, 0x0010, 0x0001,
  
  /******** Tree 8 FOPT ****************************************************/
        -1,        1,       15, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0026, 0x0014,
         7, FOPTFNT         , FOPTSAV         , G_IBOX            ,   /* Object 1  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0001, 0x0001, 0x0024, 0x0007,
  FOPTHLP         ,       -1,       -1, G_BUTTON          |0x0100,   /* Object 2 FOPTFNT */
  SELECTABLE, WHITEBAK, (LONG)"\0",
  0x0004, 0x0001, 0x001C, 0x0001,
  FOPTPOP         ,       -1,       -1, G_BUTTON          |0x0100,   /* Object 3 FOPTHLP */
  SELECTABLE, WHITEBAK, (LONG)"\0",
  0x0004, 0x0002, 0x001C, 0x0001,
  FOPTFUL         ,       -1,       -1, G_BUTTON          |0x0100,   /* Object 4 FOPTPOP */
  SELECTABLE, WHITEBAK, (LONG)"\0",
  0x0004, 0x0003, 0x001C, 0x0001,
  FOPTSAV         ,       -1,       -1, G_BUTTON          |0x0100,   /* Object 5 FOPTFUL */
  SELECTABLE, WHITEBAK, (LONG)"\0",
  0x0004, 0x0004, 0x001C, 0x0001,
         1,       -1,       -1, G_BUTTON          |0x0100,   /* Object 6 FOPTSAV */
  SELECTABLE, WHITEBAK, (LONG)"\0",
  0x0004, 0x0005, 0x001C, 0x0001,
        12, FOPTFRM         , FOPTFRM3        , G_IBOX            ,   /* Object 7  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0001, 0x0009, 0x0024, 0x0004,
  FOPTFRM1        ,       -1,       -1, G_TEXT            ,   /* Object 8 FOPTFRM */
  NONE, SELECTED, (LONG)&rs_tedinfo[39],
  0x0000, 0x0000, 0x0024, 0x0001,
  FOPTFRM2        ,       -1,       -1, G_BUTTON          |0x0200,   /* Object 9 FOPTFRM1 */
  SELECTABLE|RBUTTON, WHITEBAK, (LONG)"\0",
  0x0004, 0x0001, 0x001C, 0x0001,
  FOPTFRM3        ,       -1,       -1, G_BUTTON          |0x0200,   /* Object 10 FOPTFRM2 */
  SELECTABLE|RBUTTON, WHITEBAK, (LONG)"\0",
  0x0004, 0x0002, 0x001C, 0x0001,
         7,       -1,       -1, G_BUTTON          |0x0200,   /* Object 11 FOPTFRM3 */
  SELECTABLE|RBUTTON, WHITEBAK, (LONG)"\0",
  0x0004, 0x0003, 0x001C, 0x0001,
        15, FOPTDIR         , FOPTPHLP        , G_IBOX            ,   /* Object 12  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0001, 0x000E, 0x0024, 0x0002,
  FOPTPHLP        ,       -1,       -1, G_TEXT            ,   /* Object 13 FOPTDIR */
  NONE, SELECTED, (LONG)&rs_tedinfo[40],
  0x0000, 0x0000, 0x0024, 0x0001,
        12,       -1,       -1, G_TEXT            ,   /* Object 14 FOPTPHLP */
  SELECTABLE, WHITEBAK, (LONG)&rs_tedinfo[41],
  0x0001, 0x0001, 0x0022, 0x0001,
         0, FOPTFR          , FOPTEN          , G_IBOX            ,   /* Object 15  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0001, 0x0011, 0x0024, 0x0002,
  FOPTEN          ,       17,       17, G_BUTTON          |0x0200,   /* Object 16 FOPTFR */
  SELECTABLE|RBUTTON, WHITEBAK, (LONG)"Fran\207ais",
  0x0001, 0x0000, 0x0010, 0x0002,
  FOPTFR          ,       -1,       -1, G_CICON           ,   /* Object 17  */
  NONE, STATE15, (LONG)&rs_ciconblk[33],
  0x000C, 0x0000, 0x0004, 0x0002,
        15,       19,       19, G_BUTTON          |0x0200,   /* Object 18 FOPTEN */
  SELECTABLE|RBUTTON, WHITEBAK, (LONG)"English",
  0x0013, 0x0000, 0x0010, 0x0002,
  FOPTEN          ,       -1,       -1, G_CICON           ,   /* Object 19  */
  LASTOB, STATE15, (LONG)&rs_ciconblk[34],
  0x000C, 0x0000, 0x0004, 0x0002,
  
  /******** Tree 9 FSYS ****************************************************/
        -1,        1, FSYSFILE        , G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0026, 0x000F,
         8,        2, FSYSREZ         , G_IBOX            ,   /* Object 1  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0002, 0x0001, 0x0022, 0x0005,
  FSYSMCH         ,       -1,       -1, G_STRING          ,   /* Object 2  */
  NONE, WHITEBAK, (LONG)"Machine:",
  0x0002, 0x0001, 0x0008, 0x0001,
         4,       -1,       -1, G_STRING          ,   /* Object 3 FSYSMCH */
  NONE, WHITEBAK, (LONG)"FSYSMCH---------------",
  0x000B, 0x0001, 0x0016, 0x0001,
  FSYSPROC        ,       -1,       -1, G_STRING          ,   /* Object 4  */
  NONE, WHITEBAK, (LONG)"Proc:",
  0x0002, 0x0002, 0x0005, 0x0001,
         6,       -1,       -1, G_STRING          ,   /* Object 5 FSYSPROC */
  NONE, WHITEBAK, (LONG)"FSYSPROC--------------",
  0x000B, 0x0002, 0x0016, 0x0001,
  FSYSREZ         ,       -1,       -1, G_STRING          ,   /* Object 6  */
  NONE, WHITEBAK, (LONG)"Rez:",
  0x0002, 0x0003, 0x0004, 0x0001,
         1,       -1,       -1, G_STRING          ,   /* Object 7 FSYSREZ */
  NONE, WHITEBAK, (LONG)"FSYSREZ---------------",
  0x000B, 0x0003, 0x0016, 0x0001,
  FSYSFILE        ,        9, FSYSLET         , G_IBOX            ,   /* Object 8  */
  NONE, OUTLINED|WHITEBAK, (LONG)0x00FF1100L,
  0x0002, 0x0007, 0x0022, 0x0005,
  FSYSTOS         ,       -1,       -1, G_STRING          ,   /* Object 9  */
  NONE, WHITEBAK, (LONG)"TOS:",
  0x0003, 0x0001, 0x0004, 0x0001,
        11,       -1,       -1, G_STRING          ,   /* Object 10 FSYSTOS */
  NONE, WHITEBAK, (LONG)"FSYSTOS",
  0x0008, 0x0001, 0x0007, 0x0001,
  FSYSGDOS        ,       -1,       -1, G_STRING          ,   /* Object 11  */
  NONE, WHITEBAK, (LONG)"GDOS:",
  0x0015, 0x0001, 0x0005, 0x0001,
        13,       -1,       -1, G_STRING          ,   /* Object 12 FSYSGDOS */
  NONE, WHITEBAK, (LONG)"SYSGDOS",
  0x001B, 0x0001, 0x0007, 0x0001,
  FSYSAES         ,       -1,       -1, G_STRING          ,   /* Object 13  */
  NONE, WHITEBAK, (LONG)"AES:",
  0x0003, 0x0002, 0x0004, 0x0001,
        15,       -1,       -1, G_STRING          ,   /* Object 14 FSYSAES */
  NONE, WHITEBAK, (LONG)"FSYSAES",
  0x0008, 0x0002, 0x0007, 0x0001,
  FSYSMINT        ,       -1,       -1, G_STRING          ,   /* Object 15  */
  NONE, WHITEBAK, (LONG)"MiNT:",
  0x0015, 0x0002, 0x0005, 0x0001,
        17,       -1,       -1, G_STRING          ,   /* Object 16 FSYSMINT */
  NONE, WHITEBAK, (LONG)"SYSMINT",
  0x001B, 0x0002, 0x0007, 0x0001,
  FSYSNVDI        ,       -1,       -1, G_STRING          ,   /* Object 17  */
  NONE, WHITEBAK, (LONG)"NVDI:",
  0x0002, 0x0003, 0x0005, 0x0001,
        19,       -1,       -1, G_STRING          ,   /* Object 18 FSYSNVDI */
  NONE, WHITEBAK, (LONG)"FSYSVDI",
  0x0008, 0x0003, 0x0007, 0x0001,
  FSYSLET         ,       -1,       -1, G_STRING          ,   /* Object 19  */
  NONE, WHITEBAK, (LONG)"Let\047em Fly:",
  0x000F, 0x0003, 0x000B, 0x0001,
         8,       -1,       -1, G_STRING          ,   /* Object 20 FSYSLET */
  NONE, WHITEBAK, (LONG)"FSYSLET",
  0x001B, 0x0003, 0x0007, 0x0001,
         0,       -1,       -1, G_BUTTON          ,   /* Object 21 FSYSFILE */
  SELECTABLE|LASTOB, DRAW3D, (LONG)"\0",
  0x000A, 0x000D, 0x0014, 0x0001,
  
  /******** Tree 10 PLIB ****************************************************/
        -1, PLIBINF         , PLIBHLP         , G_BOX             ,   /* Object 0  */
  NONE, SHADOWED, (LONG)0x00FF1100L,
  0x0000, 0x0000, 0x0012, 0x0008,
  PLIBMEM         ,       -1,       -1, G_STRING          ,   /* Object 1 PLIBINF */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0000, 0x0012, 0x0001,
  PLIBFNT         ,       -1,       -1, G_STRING          ,   /* Object 2 PLIBMEM */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0001, 0x0012, 0x0001,
  PLIBOPT         ,       -1,       -1, G_STRING          ,   /* Object 3 PLIBFNT */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0002, 0x0012, 0x0001,
  PLIBSYS         ,       -1,       -1, G_STRING          ,   /* Object 4 PLIBOPT */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0003, 0x0012, 0x0001,
  PLIBCNF         ,       -1,       -1, G_STRING          ,   /* Object 5 PLIBSYS */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0004, 0x0012, 0x0001,
         7,       -1,       -1, G_STRING          ,   /* Object 6 PLIBCNF */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0005, 0x0012, 0x0001,
  PLIBHLP         ,       -1,       -1, G_STRING          ,   /* Object 7  */
  NONE, DISABLED, (LONG)"------------------",
  0x0000, 0x0006, 0x0012, 0x0001,
         0,       -1,       -1, G_STRING          ,   /* Object 8 PLIBHLP */
  SELECTABLE|LASTOB, NORMAL, (LONG)"\0",
  0x0000, 0x0007, 0x0012, 0x0001,
  
  /******** Tree 11 PHELP ****************************************************/
        -1, PHLPIND         ,       14, G_BOX             ,   /* Object 0  */
  NONE, SHADOWED, (LONG)0x00FF1100L,
  0x0000, 0x0000, 0x0016, 0x000E,
  PHLPDN          ,       -1,       -1, G_STRING          ,   /* Object 1 PHLPIND */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0000, 0x0016, 0x0001,
  PHLPUP          ,       -1,       -1, G_STRING          ,   /* Object 2 PHLPDN */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0001, 0x0016, 0x0001,
         4,       -1,       -1, G_STRING          ,   /* Object 3 PHLPUP */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0000, 0x0002, 0x0016, 0x0001,
  PHLPHIST        ,       -1,       -1, G_STRING          ,   /* Object 4  */
  NONE, DISABLED, (LONG)"----------------------",
  0x0000, 0x0003, 0x0016, 0x0001,
         6,       -1,       -1, G_STRING          ,   /* Object 5 PHLPHIST */
  SELECTABLE, NORMAL, (LONG)"----- History 0 ------",
  0x0000, 0x0004, 0x0016, 0x0001,
         7,       -1,       -1, G_STRING          ,   /* Object 6  */
  SELECTABLE, NORMAL, (LONG)"----- History 1 ------",
  0x0000, 0x0005, 0x0016, 0x0001,
         8,       -1,       -1, G_STRING          ,   /* Object 7  */
  SELECTABLE, NORMAL, (LONG)"----- History 2 ------",
  0x0000, 0x0006, 0x0016, 0x0001,
         9,       -1,       -1, G_STRING          ,   /* Object 8  */
  SELECTABLE, NORMAL, (LONG)"----- History 3 ------",
  0x0000, 0x0007, 0x0016, 0x0001,
        10,       -1,       -1, G_STRING          ,   /* Object 9  */
  SELECTABLE, NORMAL, (LONG)"----- History 4 ------",
  0x0000, 0x0008, 0x0016, 0x0001,
        11,       -1,       -1, G_STRING          ,   /* Object 10  */
  SELECTABLE, NORMAL, (LONG)"----- History 5 ------",
  0x0000, 0x0009, 0x0016, 0x0001,
        12,       -1,       -1, G_STRING          ,   /* Object 11  */
  SELECTABLE, NORMAL, (LONG)"----- History 6 ------",
  0x0000, 0x000A, 0x0016, 0x0001,
        13,       -1,       -1, G_STRING          ,   /* Object 12  */
  SELECTABLE, NORMAL, (LONG)"----- History 7 ------",
  0x0000, 0x000B, 0x0016, 0x0001,
        14,       -1,       -1, G_STRING          ,   /* Object 13  */
  SELECTABLE, NORMAL, (LONG)"----- History 8 ------",
  0x0000, 0x000C, 0x0016, 0x0001,
         0,       -1,       -1, G_STRING          ,   /* Object 14  */
  SELECTABLE|LASTOB, NORMAL, (LONG)"----- History 9 ------",
  0x0000, 0x000D, 0x0016, 0x0001,
  
  /******** Tree 12 PCOUL ****************************************************/
        -1,        1,       32, G_BOX             ,   /* Object 0  */
  NONE, SHADOWED, (LONG)0x00FF1100L,
  0x0000, 0x0000, 0x000E, 0x0010,
         2,       -1,       -1, G_STRING          ,   /* Object 1  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0000, 0x000D, 0x0001,
         3,       -1,       -1, G_STRING          ,   /* Object 2  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0001, 0x000D, 0x0001,
         4,       -1,       -1, G_STRING          ,   /* Object 3  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0002, 0x000D, 0x0001,
         5,       -1,       -1, G_STRING          ,   /* Object 4  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0003, 0x000D, 0x0001,
         6,       -1,       -1, G_STRING          ,   /* Object 5  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0004, 0x000D, 0x0001,
         7,       -1,       -1, G_STRING          ,   /* Object 6  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0005, 0x000D, 0x0001,
         8,       -1,       -1, G_STRING          ,   /* Object 7  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0006, 0x000D, 0x0001,
         9,       -1,       -1, G_STRING          ,   /* Object 8  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0007, 0x000D, 0x0001,
        10,       -1,       -1, G_STRING          ,   /* Object 9  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0008, 0x000D, 0x0001,
        11,       -1,       -1, G_STRING          ,   /* Object 10  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x0009, 0x000D, 0x0001,
        12,       -1,       -1, G_STRING          ,   /* Object 11  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x000A, 0x000D, 0x0001,
        13,       -1,       -1, G_STRING          ,   /* Object 12  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x000B, 0x000D, 0x0001,
        14,       -1,       -1, G_STRING          ,   /* Object 13  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x000C, 0x000D, 0x0001,
        15,       -1,       -1, G_STRING          ,   /* Object 14  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x000D, 0x000D, 0x0001,
        16,       -1,       -1, G_STRING          ,   /* Object 15  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x000E, 0x000D, 0x0001,
        17,       -1,       -1, G_STRING          ,   /* Object 16  */
  SELECTABLE, NORMAL, (LONG)"\0",
  0x0001, 0x000F, 0x000D, 0x0001,
        18,       -1,       -1, G_BOX             ,   /* Object 17  */
  NONE, NORMAL, (LONG)0x000011F0L,
  0x0000, 0x0000, 0x0001, 0x0001,
        19,       -1,       -1, G_BOX             ,   /* Object 18  */
  NONE, NORMAL, (LONG)0x000011F1L,
  0x0000, 0x0001, 0x0001, 0x0001,
        20,       -1,       -1, G_BOX             ,   /* Object 19  */
  NONE, NORMAL, (LONG)0x000011F2L,
  0x0000, 0x0002, 0x0001, 0x0001,
        21,       -1,       -1, G_BOX             ,   /* Object 20  */
  NONE, NORMAL, (LONG)0x000011F3L,
  0x0000, 0x0003, 0x0001, 0x0001,
        22,       -1,       -1, G_BOX             ,   /* Object 21  */
  NONE, NORMAL, (LONG)0x000011F4L,
  0x0000, 0x0004, 0x0001, 0x0001,
        23,       -1,       -1, G_BOX             ,   /* Object 22  */
  NONE, NORMAL, (LONG)0x000011F5L,
  0x0000, 0x0005, 0x0001, 0x0001,
        24,       -1,       -1, G_BOX             ,   /* Object 23  */
  NONE, NORMAL, (LONG)0x000011F6L,
  0x0000, 0x0006, 0x0001, 0x0001,
        25,       -1,       -1, G_BOX             ,   /* Object 24  */
  NONE, NORMAL, (LONG)0x000011F7L,
  0x0000, 0x0007, 0x0001, 0x0001,
        26,       -1,       -1, G_BOX             ,   /* Object 25  */
  NONE, NORMAL, (LONG)0x000011F8L,
  0x0000, 0x0008, 0x0001, 0x0001,
        27,       -1,       -1, G_BOX             ,   /* Object 26  */
  NONE, NORMAL, (LONG)0x000011F9L,
  0x0000, 0x0009, 0x0001, 0x0001,
        28,       -1,       -1, G_BOX             ,   /* Object 27  */
  NONE, NORMAL, (LONG)0x000011FAL,
  0x0000, 0x000A, 0x0001, 0x0001,
        29,       -1,       -1, G_BOX             ,   /* Object 28  */
  NONE, NORMAL, (LONG)0x000011FBL,
  0x0000, 0x000B, 0x0001, 0x0001,
        30,       -1,       -1, G_BOX             ,   /* Object 29  */
  NONE, NORMAL, (LONG)0x000011FCL,
  0x0000, 0x000C, 0x0001, 0x0001,
        31,       -1,       -1, G_BOX             ,   /* Object 30  */
  NONE, NORMAL, (LONG)0x000011FDL,
  0x0000, 0x000D, 0x0001, 0x0001,
        32,       -1,       -1, G_BOX             ,   /* Object 31  */
  NONE, NORMAL, (LONG)0x000011FEL,
  0x0000, 0x000E, 0x0001, 0x0001,
         0,       -1,       -1, G_BOX             ,   /* Object 32  */
  LASTOB, NORMAL, (LONG)0x000011FFL,
  0x0000, 0x000F, 0x0001, 0x0001,
  
  /******** Tree 13 ICONE ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[42],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  LASTOB, STATE15, (LONG)&rs_ciconblk[35],
  0x0002, 0x0001, 0x0004, 0x0002,
  
  /******** Tree 14 ICINF ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[43],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  LASTOB, STATE15, (LONG)&rs_ciconblk[36],
  0x0002, 0x0001, 0x0004, 0x0002,
  
  /******** Tree 15 ICMEM ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[44],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  SELECTABLE|LASTOB, STATE15, (LONG)&rs_ciconblk[37],
  0x0002, 0x0001, 0x0004, 0x0002,
  
  /******** Tree 16 ICFNT ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[45],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  SELECTABLE|LASTOB, STATE15, (LONG)&rs_ciconblk[38],
  0x0002, 0x0001, 0x0004, 0x0002,
  
  /******** Tree 17 ICOPT ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[46],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  SELECTABLE|LASTOB, STATE15, (LONG)&rs_ciconblk[39],
  0x0001, 0x0001, 0x0006, 0x0002,
  
  /******** Tree 18 ICSYS ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[47],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  LASTOB, STATE15, (LONG)&rs_ciconblk[40],
  0x0002, 0x0001, 0x0004, 0x0002,
  
  /******** Tree 19 ICHLP ****************************************************/
        -1,        1,        2, G_BOX             ,   /* Object 0  */
  NONE, WHITEBAK, (LONG)0x00FF1180L,
  0x0000, 0x0000, 0x0208, 0x0003,
         2,       -1,       -1, G_BOXTEXT         ,   /* Object 1  */
  SELECTABLE|EXIT, SELECTED|STATE9, (LONG)&rs_tedinfo[48],
  0x0000, 0x0000, 0x0208, 0x0001,
         0,       -1,       -1, G_CICON           ,   /* Object 2  */
  SELECTABLE|LASTOB, STATE15, (LONG)&rs_ciconblk[41],
  0x0002, 0x0001, 0x0004, 0x0002
};

static  OBJECT *rs_trindex[] =
{ &rs_object[0],   /* Tree  0 HWIN             */
  &rs_object[18],   /* Tree  1 LWIN             */
  &rs_object[36],   /* Tree  2 FPOP             */
  &rs_object[43],   /* Tree  3 FUSER            */
  &rs_object[62],   /* Tree  4 FMOUSE           */
  &rs_object[76],   /* Tree  5 FINF             */
  &rs_object[93],   /* Tree  6 FMEM             */
  &rs_object[101],   /* Tree  7 FFNT             */
  &rs_object[119],   /* Tree  8 FOPT             */
  &rs_object[139],   /* Tree  9 FSYS             */
  &rs_object[161],   /* Tree 10 PLIB             */
  &rs_object[170],   /* Tree 11 PHELP            */
  &rs_object[185],   /* Tree 12 PCOUL            */
  &rs_object[218],   /* Tree 13 ICONE            */
  &rs_object[221],   /* Tree 14 ICINF            */
  &rs_object[224],   /* Tree 15 ICMEM            */
  &rs_object[227],   /* Tree 16 ICFNT            */
  &rs_object[230],   /* Tree 17 ICOPT            */
  &rs_object[233],   /* Tree 18 ICSYS            */
  &rs_object[236]    /* Tree 19 ICHLP            */
};
